from enum import IntEnum

class ErrorCode2(IntEnum):
    SUCCESS = 0x00000000
    Warning = 0x10000000
    FuncError = 0x80000000
    CommError = 0x80010000
    MotionError = 0x80020000
    DaqError = 0x80030000
    DevEvtError = 0x80040000
    DspError = 0x80050000
    DspAxError = 0x80051000
    DspGpError = 0x80052000
    DspRbError = 0x80055000
    GmError = 0x81000000
    Gm_CodeError = 0x81000100
    Gm_SystemError = 0x81000200
    ComponentError = 0x82000000
    # Add for EtherCAT
    ECTError = 0x83000000
    # EtherCAT main & sub device error 
    ECTDevError = 0x83010000
    # from SDO communication 0x8301 XXXX
    ECTDevSDOError = 0x83020000
    # from Motion port communication
    ECTMotionError = 0x83030000
    # from IO port communication
    ECTIOError = 0x83040000
    # from CiA402 ecat driver
    ECTAxError = 0x83050000
    # from Motion port communication
    ECTMotionConnError = 0x83060000
    # from IO port communication
    ECTIOConnError = 0x83070000
    # EtherCAT Drive error 
    ECAT_DriveError = 0x83100000
    ENETClientError = 0x84000000
    ENETServerError = 0x85000000
    InvalidDevNumber = (FuncError + 0)
    DevRegDataLost = (FuncError + 1)
    LoadDllFailed = (FuncError + 2)
    GetProcAddrFailed = (FuncError + 3)
    MemAllocateFailed = (FuncError + 4)
    InvalidHandle = (FuncError + 5)
    CreateFileFailed = (FuncError + 6)
    OpenEventFailed = (FuncError + 7)
    EventTimeOut = (FuncError + 8)
    InvalidInputParam = (FuncError + 9)
    PropertyIDNotSupport = (FuncError + 10)
    PropertyIDReadOnly = (FuncError + 11)
    ConnectWinIrqFailed = (FuncError + 12)
    InvalidAxCfgVel = (FuncError + 13)
    InvalidAxCfgAcc = (FuncError + 14)
    InvalidAxCfgDec = (FuncError + 15)
    InvalidAxCfgJerk = (FuncError + 16)
    InvalidAxParVelLow = (FuncError + 17)
    InvalidAxParVelHigh = (FuncError + 18)
    InvalidAxParAcc = (FuncError + 19)
    InvalidAxParDec = (FuncError + 20)
    InvalidAxParJerk = (FuncError + 21)
    InvalidAxPulseInMode = (FuncError + 22)
    InvalidAxPulseOutMode = (FuncError + 23)
    InvalidAxAlarmEn = (FuncError + 24)
    InvalidAxAlarmLogic = (FuncError + 25)
    InvalidAxInPEn = (FuncError + 26)
    InvalidAxInPLogic = (FuncError + 27)
    InvalidAxHLmtEn = (FuncError + 28)
    InvalidAxHLmtLogic = (FuncError + 29)
    InvalidAxHLmtReact = (FuncError + 30)
    InvalidAxSLmtPEn = (FuncError + 31)
    InvalidAxSLmtPReact = (FuncError + 32)
    InvalidAxSLmtPValue = (FuncError + 33)
    InvalidAxSLmtMEn = (FuncError + 34)
    InvalidAxSLmtMReact = (FuncError + 35)
    InvalidAxSLmtMValue = (FuncError + 36)
    InvalidAxOrgLogic = (FuncError + 37)
    InvalidAxOrgEnable = (FuncError + 38)
    InvalidAxEzLogic = (FuncError + 39)
    InvalidAxEzEnable = (FuncError + 40)
    InvalidAxEzCount = (FuncError + 41)
    InvalidAxState = (FuncError + 42)
    InvalidAxInEnable = (FuncError + 43)
    InvalidAxSvOnOff = (FuncError + 44)
    InvalidAxDistance = (FuncError + 45)
    InvalidAxPosition = (FuncError + 46)
    InvalidAxHomeModeKw = (FuncError + 47)
    InvalidAxCntInGp = (FuncError + 48)
    AxInGpNotFound = (FuncError + 49)
    AxIsInOtherGp = (FuncError + 50)
    AxCannotIntoGp = (FuncError + 51)
    GpInDevNotFound = (FuncError + 52)
    InvalidGpCfgVel = (FuncError + 53)
    InvalidGpCfgAcc = (FuncError + 54)
    InvalidGpCfgDec = (FuncError + 55)
    InvalidGpCfgJerk = (FuncError + 56)
    InvalidGpParVelLow = (FuncError + 57)
    InvalidGpParVelHigh = (FuncError + 58)
    InvalidGpParAcc = (FuncError + 59)
    InvalidGpParDec = (FuncError + 60)
    InvalidGpParJerk = (FuncError + 61)
    JerkNotSupport = (FuncError + 62)
    ThreeAxNotSupport = (FuncError + 63)
    DevIpoNotFinished = (FuncError + 64)
    InvalidGpState = (FuncError + 65)
    OpenFileFailed = (FuncError + 66)
    InvalidPathCnt = (FuncError + 67)
    InvalidPathHandle = (FuncError + 68)
    InvalidPath = (FuncError + 69)
    IoctlError = (FuncError + 70)
    AmnetRingUsed = (FuncError + 71)
    DeviceNotOpened = (FuncError + 72)
    InvalidRing = (FuncError + 73)
    InvalidSubDeviceIP = (FuncError + 74)
    InvalidParameter = (FuncError + 75)
    InvalidGpCenterPosition = (FuncError + 76)
    InvalidGpEndPosition = (FuncError + 77)
    InvalidAddress = (FuncError + 78)
    DeviceDisconnect = (FuncError + 79)
    DataOutBufExceeded = (FuncError + 80)
    SubDeviceNotMatch = (FuncError + 81)
    SubDeviceError = (FuncError + 82)
    SubDeviceUnknow = (FuncError + 83)
    FunctionNotSupport = (FuncError + 84)
    InvalidPhysicalAxis = (FuncError + 85)	
    InvalidVelocity = (FuncError + 86)
    InvalidAxPulseInLogic = (FuncError + 87)
    InvalidAxPulseInSource = (FuncError + 88)
    InvalidAxErcLogic = (FuncError + 89)
    InvalidAxErcOnTime = (FuncError + 90)
    InvalidAxErcOffTime = (FuncError + 91)
    InvalidAxErcEnableMode = (FuncError + 92)
    InvalidAxSdEnable = (FuncError + 93)
    InvalidAxSdLogic = (FuncError + 94)
    InvalidAxSdReact = (FuncError + 95)
    InvalidAxSdLatch = (FuncError + 96)
    InvalidAxHomeResetEnable = (FuncError + 97)
    InvalidAxBacklashEnable = (FuncError + 98)
    InvalidAxBacklashDistance = (FuncError + 99)
    InvalidAxVibrationEnable = (FuncError + 100)
    InvalidAxVibrationRevTime = (FuncError + 101)
    InvalidAxVibrationFwdTime = (FuncError + 102)
    InvalidAxAlarmReact = (FuncError + 103)
    InvalidAxLatchLogic = (FuncError + 104)
    InvalidFwMemoryMode = (FuncError + 105)
    InvalidConfigFile = (FuncError + 106)
    InvalidAxEnEvtArraySize = (FuncError + 107)
    InvalidAxEnEvtArray = (FuncError + 108)
    InvalidGpEnEvtArraySize = (FuncError + 109)
    InvalidGpEnEvtArray = (FuncError + 110)
    InvalidIntervalData = (FuncError + 111)
    InvalidEndPosition = (FuncError + 112)
    InvalidAxisSelect = (FuncError + 113)
    InvalidTableSize = (FuncError + 114)
    InvalidGpHandle = (FuncError + 115)
    InvalidCmpSource = (FuncError + 116)
    InvalidCmpMethod = (FuncError + 117)
    InvalidCmpPulseMode = (FuncError + 118)
    InvalidCmpPulseLogic = (FuncError + 119)
    InvalidCmpPulseWidth = (FuncError + 120)
    InvalidPathFunctionID = (FuncError + 121)
    SysBufAllocateFailed = (FuncError + 122)
    SpeedFordFunNotSupported= (FuncError + 123)
    InvalidNormVector = (FuncError + 124)
    InvalidCmpTimeTableCount= (FuncError + 125)
    InvalidCmpTime = (FuncError + 126)
    FWDownLoading = (FuncError + 127)
    FWVersionNotMatch = (FuncError + 128)
    InvalidAxParHomeVelLow = (FuncError + 129)
    InvalidAxParHomeVelHigh = (FuncError + 130)
    InvalidAxParHomeAcc = (FuncError + 131)
    InvalidAxParHomeDec = (FuncError + 132)
    InvalidAxParHomeJerk = (FuncError + 133)
    InvalidAxCfgJogVelLow = (FuncError + 134)
    InvalidAxCfgJogVelHigh = (FuncError + 135)
    InvalidAxCfgJogAcc = (FuncError + 136)
    InvalidAxCfgJogDec = (FuncError + 137)
    InvalidAxCfgJogJerk = (FuncError + 138)
    InvalidAxCfgKillDec = (FuncError + 139)
    NotOpenAllAxes = (FuncError + 140)
    NotSetServoComPort = (FuncError + 141)
    OpenComPortFailed = (FuncError + 142)
    ReadComPortTimeOut = (FuncError + 143)
    SetComPortStateFailed = (FuncError + 144)
    ServoTypeNotSupport = (FuncError + 145)
    ReadComBufFailed = (FuncError + 146)
    InvalidAxMaxErrorCnt = (FuncError + 147)
    MoveModeNosupportBlend = (FuncError + 148)
    CmpModeCannotGenDO = (FuncError + 149)
    # AMONet Communication error
    SubDeviceIOUpdateError = (FuncError + 150)
    NoSubDevFound = (FuncError + 151)
    MainDevNotOpen = (FuncError + 152)
    MainRingNotOpen = (FuncError + 153)
    CannotFindCenterby3P = (FuncError + 154)
    InvalidAxCfgJogPAssign = (FuncError + 155)
    InvalidAxCfgJogNAssign = (FuncError + 156)
    InvalidAxCfgCamDOAssign = (FuncError + 157)
    InvalidAxCfgDIStopAssign= (FuncError + 158)
    PDONotAssign = (FuncError + 159)
    GpHadBeenModified = (FuncError + 160)
    PDOReadOnlyObject = (FuncError + 161)
    OpenFileSizeFailed = (FuncError + 162)
    OpenFilePathFailed = (FuncError + 163)
    InvalidFileName = (FuncError + 164)
    # DAQ function
    InvalidDIPort = (FuncError + 200)
    InvalidDOPort = (FuncError + 201)
    InvalidDOValue = (FuncError + 202)
    # EVT function
    CreateEventFailed = (FuncError + 203)
    CreateThreadFailed = (FuncError + 204)
    InvalidHomeModeEx = (FuncError + 205)
    InvalidDirMode = (FuncError + 206)
    AxHomeMotionFailed = (FuncError + 207)
    ReadFileFailed = (FuncError + 208)
    PathBufIsFull = (FuncError + 209)
    PathBufIsEmpty = (FuncError + 210)
    GetAuthorityFailed = (FuncError + 211)
    GpIDAllocatedFailed = (FuncError + 212)
    FirmWareDown = (FuncError + 213)
    InvalidGpRadius = (FuncError + 214)
    InvalidAxCmd = (FuncError + 215)
    InvalidAxExtDrv = (FuncError + 216)
    InvalidGpMovCmd = (FuncError + 217)
    SpeedCurveNotSupported = (FuncError + 218)
    InvalidCounterNo = (FuncError + 219)
    InvalidPathMoveMode	 = (FuncError + 220)
    PathSelStartCantRunInSpeedForwareMode = (FuncError + 221)
    InvalidCamTableID = (FuncError + 222)
    InvalidCamPointRange = (FuncError + 223)
    CamTableIsEmpty = (FuncError + 224)
    InvalidPlaneVector = (FuncError + 225)
    PrimaryAxIDSameFollowingAxID = (FuncError + 226)
    InvalidGpRefPlane = (FuncError + 227)
    InvalidAxModuleRange = (FuncError + 228)
    DownloadFileFailed = (FuncError + 229)
    InvalidFileLength = (FuncError + 230) 
    InvalidCmpCnt = (FuncError + 231)
    JerkExceededMaxValue = (FuncError + 232)
    AbsMotionNotSupport = (FuncError + 233)
    InvalidAiRange = (FuncError + 234)
    AIScaleFailed = (FuncError + 235)
    AxInRobot = (FuncError + 236)
    Invalid3DArcFlat	 = (FuncError + 237)
    InvalidIpoMap = (FuncError + 238)
    DataSizeNotCorrect	 = (FuncError + 239)
    AxisNotFound = (FuncError + 240)
    InvalidPathVelHigh = (FuncError + 241)
    InvalidRbParVelLow = (FuncError + 250)
    InvalidRbParVelHigh = (FuncError + 251)
    InvalidRbParAcc = (FuncError + 252)
    InvalidRbParDec = (FuncError + 253)
    InvalidRbParJerk = (FuncError + 254)
    InvalidRbState = (FuncError + 255)
    InvalidRbHandle = (FuncError + 256)
    InvalidRbRadius = (FuncError + 257)
    InvalidRbMovCmd = (FuncError + 258)
    NotOpenRobot = (FuncError + 259) 
    InvalidRbPoint = (FuncError + 260)
    RbAngleExceeded = (FuncError + 261)
    GetDIOFailed = (FuncError + 300)
    InvalidRingBufferCmd = (FuncError + 301)
    InvalidAoRange = (FuncError + 302)
    RingBufferOverFlow	 = (FuncError + 303)
    RbAreaExceeded = (FuncError + 304)
    InvalidAiValue = (FuncError + 305)
    InvalidAoValue = (FuncError + 306)
    NoPreScanData = (FuncError + 307)
    GroupNotAssigned = (FuncError + 308)
    AxisNotOpened = (FuncError + 309)
    DataCntExceeded = (FuncError + 310)
    InvalidCamTable = (FuncError + 311)
    CompareIntervalorPartsCalcuFail	= (FuncError + 312)
    CmpIntervalorPartsExceedMax= (FuncError + 313)
    LinkObjectNotAssigned = (FuncError + 314)
    HLmtPExceeded = (MotionError)
    HLmtNExceeded = (MotionError + 1)
    SLmtPExceeded = (MotionError + 2)
    SLmtNExceeded = (MotionError + 3)
    AlarmHappened = (MotionError + 4)
    EmgHappened = (MotionError + 5)
    TimeLmtExceeded = (MotionError + 6)
    DistLmtExceeded = (MotionError + 7)
    InvalidPositionOverride = (MotionError + 8)
    OperationErrorHappened = (MotionError + 9)
    SimultaneousStopHappened= (MotionError + 10)
    OverflowInPAPB = (MotionError + 11)
    OverflowInIPO = (MotionError + 12)
    STPHappened = (MotionError + 13)
    SDHappened = (MotionError + 14)
    AxisNoCmpDataLeft = (MotionError + 15)
    DevEvtTimeOut = (DevEvtError + 1)
    DevNoEvt = (DevEvtError + 2)
    Warning_AxWasInGp = (Warning + 1)
    # inconsistent rate of PPU setting
    Warning_GpInconsistRate = (Warning + 2)
    Warning_GpInconsistPPU = (Warning + 3)
    Warning_GpMoveDistanceCanntBeZero= (Warning + 4)
    Warning_GpExisted = (Warning + 5)
    # Dsp Error
    ERR_SYS_TIME_OUT = (DspError + 1)
    Dsp_PropertyIDNotSupport = (DspError + 2)
    Dsp_PropertyIDReadOnly = (DspError + 3)
    Dsp_InvalidParameter = (DspError + 4)
    Dsp_DataOutBufExceeded = (DspError + 5)
    Dsp_FunctionNotSupport = (DspError + 6)
    Dsp_InvalidConfigFile = (DspError + 7)
    Dsp_InvalidIntervalData = (DspError + 8)
    Dsp_InvalidTableSize = (DspError + 9)
    Dsp_InvalidTableID = (DspError + 10)
    Dsp_DataIndexExceedBufSize = (DspError + 11)
    Dsp_InvalidCompareInterval = (DspError + 12)
    Dsp_InvalidCompareRange = (DspError + 13)
    Dsp_PropertyIDWriteOnly = (DspError + 14)
    Dsp_NcError = (DspError + 15)	
    Dsp_CamTableIsInUse	 = (DspError + 16)	
    Dsp_EraseBlockFailed = (DspError + 17)	
    Dsp_ProgramFlashFailed = (DspError + 18)	
    Dsp_WatchdogError = (DspError + 19)	
    Dsp_ReadPrivateOverMaxTimes= (DspError + 20)
    Dsp_InvalidPrivateID = (DspError + 21)
    Dsp_DataNotReady = (DspError + 22)
    Dsp_LastOperationNotOver = (DspError + 23)
    Dsp_WritePrivateTimeout = (DspError + 24)
    Dsp_FwIsDownloading	 = (DspError + 25)
    Dsp_FwDownloadStepError = (DspError + 26)
    Dsp_InvalidDiLtcChannelID = (DspError + 27)
    Dsp_InvalidDoCmpChannelID = (DspError + 28)
    Dsp_InvalidDevPptValue = (DspError + 29)
    Dsp_CmpCannotLinkMultiLtc= (DspError + 30)
    Dsp_SDIOLinkError = (DspError + 31)
    InvalidVerScanTable = (DspError + 32)
    InvalidVerEnablePos = (DspError + 33)
    VerMovLimitExceeded = (DspError + 34)
    Dsp_InvalidTableName = (DspError + 35)
    Dsp_SubDeviceDoNotSupportSDO = (DspError + 36) 
    Dsp_InvalidForceTrigger = (DspError + 37)
    Dsp_InvalidSetCompareChannel = (DspError + 38)
    Dsp_InvalidCompareChannelIsUsed	= (DspError + 39)
    Dsp_InvalidSetCompareAddTable = (DspError + 40)
    Dsp_InvalidAddCompareTableFile = (DspError + 41)
    Dsp_MIOInvalidSer = (DspError + 42)
    Dsp_SDIInvalidSer = (DspError + 43)
    Plink_SynTimeTooShort = (DspError + 44)
    Dsp_LinkObjectExisted = (DspError + 45)
    Dsp_InvalidLatchChannelIsUsed	= (DspError + 46)
    Dsp_InvalidLtcChannelOnlyUseOne	= (DspError + 47)
    Dsp_InvalidSoftAxisID = (DspError + 48)
    Dsp_InvalidAxisIsNotSetByLatch	= (DspError + 49)
    Dsp_InvalidLatchAxisIsNotLocal	= (DspError + 50)
    Dsp_InvalidCmpChannelOnlyUseOne	= (DspError + 51)
    Dsp_InvalidCmpAxisisUsedByOtherCh= (DspError + 52)
    Dsp_InvalidSetPwmChannel = (DspError + 53)
    Dsp_InvalidPwmChannelIsUsed = (DspError + 54)
    Dsp_InvalidPwmChannelOnlyUseOne	= (DspError + 55)
    Dsp_MotionAPResetUnknown = (DspError + 56)
    Dsp_MotionAPResetZero = (DspError + 57)
    Dsp_MotionAPResetNormalError = (DspError + 58)
    Dsp_MotionAPResetSegfault = (DspError + 59)
    Dsp_MotionAPResetAbnormal = (DspError + 60)
    # Axis Error
    Dsp_InvalidAxCfgVel = (DspAxError + 1)
    Dsp_InvalidAxCfgAcc = (DspAxError + 2)
    Dsp_InvalidAxCfgDec = (DspAxError + 3)
    Dsp_InvalidAxCfgJerk = (DspAxError + 4)
    Dsp_InvalidAxParVelLow = (DspAxError + 5)
    Dsp_InvalidAxParVelHigh = (DspAxError + 6)
    Dsp_InvalidAxParAcc = (DspAxError + 7)
    Dsp_InvalidAxParDec = (DspAxError + 8)
    Dsp_InvalidAxParJerk = (DspAxError + 9)
    Dsp_InvalidAxPptValue = (DspAxError + 10)
    Dsp_InvalidAxState = (DspAxError + 11)
    Dsp_InvalidAxSvOnOff = (DspAxError + 12)
    Dsp_InvalidAxDistance = (DspAxError + 13)
    Dsp_InvalidAxPosition = (DspAxError + 14)
    Dsp_InvalidAxHomeMode = (DspAxError + 15)
    Dsp_InvalidPhysicalAxis = (DspAxError + 16)
    Dsp_HLmtPExceeded = (DspAxError + 17)
    Dsp_HLmtNExceeded = (DspAxError + 18)
    Dsp_SLmtPExceeded = (DspAxError + 19)
    Dsp_SLmtNExceeded = (DspAxError + 20)
    Dsp_AlarmHappened = (DspAxError + 21)
    Dsp_EmgHappened = (DspAxError + 22)
    # Command valid only in the constant section
    Dsp_CmdValidOnlyInConstSec= (DspAxError + 23)
    Dsp_InvalidAxCmd = (DspAxError + 24)
    Dsp_InvalidAxHomeDirMode = (DspAxError + 25)
    Dsp_AxisMustBeModuloAxis = (DspAxError + 26)
    Dsp_AxIdCantSameAsPrimaryId = (DspAxError + 27)
    Dsp_CantResetPosiOfPrimaryAxis = (DspAxError + 28)
    Dsp_InvalidAxExtDrvOperation = (DspAxError + 29)
    Dsp_AxAccExceededMaxAcc = (DspAxError + 30)
    Dsp_AxVelExceededMaxVel = (DspAxError + 31)
    Dsp_NotEnoughPulseForChgV = (DspAxError + 32)
    Dsp_NewVelMustGreaterThanVelLow	= (DspAxError + 33)
    Dsp_InvalidAxGearMode = (DspAxError + 34)
    Dsp_InvalidGearRatio = (DspAxError + 35)
    Dsp_InvalidPWMDataCount = (DspAxError + 36)
    Dsp_InvalidAxPWMFreq = (DspAxError + 37)
    Dsp_InvalidAxPWMDuty = (DspAxError + 38)
    Dsp_AxGantryExceedMaxDiffValue	= (DspAxError + 39)
    Dsp_ChannelIsDisable = (DspAxError + 40)
    Dsp_ChannelBufferIsFull = (DspAxError + 41)
    Dsp_ChannelBufferIsEmpty = (DspAxError + 42)
    Dsp_InvalidDoChannelID = (DspAxError + 43)
    Dsp_LatchHappened = (DspAxError + 44)
    Dsp_InvalidAxKillDec = (DspAxError + 45)
    Dsp_InvalidAxJogVelLow = (DspAxError + 46)
    Dsp_InvalidAxJogVelHigh = (DspAxError + 47)
    Dsp_InvalidAxJogAcc = (DspAxError + 48)
    Dsp_InvalidAxJogDec = (DspAxError + 49)
    Dsp_InvalidAxJogJerk = (DspAxError + 50)
    Dsp_InvalidAxHomeVelLow = (DspAxError + 51)
    Dsp_InvalidAxHomeVelHigh= (DspAxError + 52)
    Dsp_InvalidAxHomeAcc = (DspAxError + 53)
    Dsp_InvalidAxHomeDec = (DspAxError + 54)
    Dsp_InvalidAxHomeJerk = (DspAxError + 55)
    Dsp_PosErrorCntExceed = (DspAxError + 56)
    # ring counter
    Dsp_InvalidAxCounterMax = (DspAxError + 57)
    Dsp_InvalidAxOverflowMode = (DspAxError + 58)
    Dsp_ImposeTimeLongerPTP = (DspAxError + 59)
    Dsp_AxAngExceededMaxRotationAng	= (DspAxError + 60)
    Dsp_AxAreaExceeded = (DspAxError + 61)
    # For guanghaojie
    Dsp_AxDiStopAct = (DspAxError + 62)
    Dsp_SWPELIsDisable = (DspAxError + 63)
    Dsp_SWMELIsDisable = (DspAxError + 64)
    Dsp_CMPIsDisable = (DspAxError + 65)
    Dsp_AxDisConnect = (DspAxError + 66)
    Dsp_InvalidAxType = (DspAxError + 67)
    # Group Error
    Dsp_InvalidAxCntInGp = (DspGpError + 1)
    Dsp_AxInGpNotFound = (DspGpError + 2)
    Dsp_AxIsInOtherGp = (DspGpError + 3)
    Dsp_AxCannotIntoGp = (DspGpError + 4)
    Dsp_GpInDevNotFound = (DspGpError + 5)
    Dsp_InvalidGpCfgVel = (DspGpError + 6)
    Dsp_InvalidGpCfgAcc = (DspGpError + 7)
    Dsp_InvalidGpCfgDec = (DspGpError + 8)
    Dsp_InvalidGpCfgJerk = (DspGpError + 9)
    Dsp_InvalidGpParVelLow = (DspGpError + 10)
    Dsp_InvalidGpParVelHigh = (DspGpError + 11)
    Dsp_InvalidGpParAcc = (DspGpError + 12)
    Dsp_InvalidGpParDec = (DspGpError + 13)
    Dsp_InvalidGpParJerk = (DspGpError + 14)
    Dsp_JerkNotSupport = (DspGpError + 15)
    Dsp_ThreeAxNotSupport = (DspGpError + 16)
    Dsp_DevIpoNotFinished = (DspGpError + 17)
    Dsp_InvalidGpState = (DspGpError + 18)
    Dsp_OpenFileFailed = (DspGpError + 19)
    Dsp_InvalidPathCnt = (DspGpError + 20)
    Dsp_InvalidPathHandle = (DspGpError + 21)
    Dsp_InvalidPath = (DspGpError + 22)
    Dsp_GpFollowingPositionOverPrimary = (DspGpError + 23)
    Dsp_GpPathBufferOverflow = (DspGpError + 24)
    Dsp_InvalidPathFunctionID= (DspGpError + 25)
    Dsp_SysBufAllocateFailed= (DspGpError + 26)
    Dsp_InvalidGpCenterPosition= (DspGpError + 27)
    Dsp_InvalidGpEndPosition= (DspGpError + 28)
    Dsp_InvalidGpCmd = (DspGpError + 29)
    Dsp_AxHasBeenInInGp	 = (DspGpError + 30)
    Dsp_InvalidPathRange = (DspGpError + 31)
    Dsp_InvalidNormVector = (DspGpError + 32)
    Dsp_NotANumber = (DspGpError + 33)
    Dsp_UnknownCmdID = (DspGpError + 34)
    Dsp_InvalidJumpPosi = (DspGpError + 35)
    Dsp_DivideByZero = (DspGpError + 36)
    Dsp_IrVersionNotSupport = (DspGpError + 37)
    Dsp_InvalidIrSource	 = (DspGpError + 38)
    Dsp_InvalidVariableAddress = (DspGpError + 39)
    Dsp_IntprIsRunning = (DspGpError + 40)
    Dsp_ProgramNotloaded = (DspGpError + 41)
    Dsp_BreakPointsFulled = (DspGpError + 42)
    Dsp_MotionRTError = (DspGpError + 43)
    Dsp_AresAxisConflict = (DspGpError + 44)
    Dsp_CannotBeNegValue = (DspGpError + 45)
    Dsp_AresAxisNotSupport = (DspGpError + 46)
    Dsp_AresAxisNotDefine = (DspGpError + 47)
    Dsp_AresNotFindPATHEND = (DspGpError + 48)
    Dsp_AresMotionQueueFull = (DspGpError + 49)
    Dsp_AresInvalidProcID = (DspGpError + 50)
    Dsp_AresNotFindActionCommand = (DspGpError + 51)
    Dsp_AresCmdNotSupportActionCmd = (DspGpError + 52)
    Dsp_AresCmdNotSupportMotionCmd = (DspGpError + 53)
    Dsp_AresPathTableNotSupportCmd = (DspGpError + 54)
    Dsp_AresPauseNotSupport = (DspGpError + 55)
    Dsp_AresPathTableCountError = (DspGpError + 56)
    Dsp_AresAddPathAfterStop = (DspGpError + 57)
    Dsp_AresRotateAxisNotFind = (DspGpError + 58)
    Dsp_AresRotateOnlySupportOneRotatePlane = (DspGpError + 59)
    Dsp_AresRotateOffsetInvalid = (DspGpError + 60)
    Dsp_AresInvalidTriggerMode = (DspGpError + 61)
    Dsp_AresCompareIntervalorPartsNotSupport = (DspGpError + 62)
    Dsp_AresCompareArcAxisNotFind = (DspGpError + 63)
    Dsp_GpNotReturnPausePosi = (DspGpError + 64)
    Dsp_RbInvalidMode = (DspRbError)
    Dsp_RbInvalidGpid = (DspRbError + 1)
    Dsp_RbInvalidArmLength = (DspRbError + 2)
    Dsp_RbInvalidAxesNum = (DspRbError + 3)
    Dsp_RbInvalidHandDir = (DspRbError + 4)
    Dsp_RbAreaExceeded = (DspRbError + 5)
    Dsp_RbAngleExceeded = (DspRbError + 6)
    Dsp_RbSwLmtNotEnabled = (DspRbError + 7)
    Dsp_RbVectorDistExceededZTargetDist = (DspRbError + 8)
    Dsp_RbInvalidPoint = (DspRbError + 9)
    Dsp_RbInvalidCurrentHandDir = (DspRbError + 10)
    Dsp_RbInvalidCoordinateSystem = (DspRbError + 11)
    Dsp_RbInvalidCoordinateAxis = (DspRbError + 12)
    Dsp_RbSpeedTooHigh = (DspRbError + 13)
    Dsp_RbInvalidState = (DspRbError + 14)
    Dsp_RbEmgHappened = (DspRbError + 15)
    Dsp_RbAlmHappened = (DspRbError + 16)
    Dsp_RbSLmtPExceeded = (DspRbError + 17)
    Dsp_RbSLmtNExceeded = (DspRbError + 18)
    Dsp_RbPosHandDirNotMatch = (DspRbError + 19)
    # Gm_CodeError
    Gm_InvalidCharacter = (Gm_CodeError + 1)
    Gm_InvalidCode = (Gm_CodeError + 2)
    Gm_InvalidGCode = (Gm_CodeError + 3)
    Gm_InvalidMCode = (Gm_CodeError + 4)
    Gm_GroupCodeAlreadyExist = (Gm_CodeError + 5)
    Gm_MissingNumber = (Gm_CodeError + 6)
    Gm_MissingFWord = (Gm_CodeError + 7)
    Gm_MissingSWord = (Gm_CodeError + 8)
    Gm_MissingOWord = (Gm_CodeError + 9)
    Gm_MissingNWord = (Gm_CodeError + 10)
    Gm_MissingLWord = (Gm_CodeError + 11)
    Gm_MissingPWord = (Gm_CodeError + 12)
    Gm_MissingQWord = (Gm_CodeError + 13)
    Gm_MissingRWord = (Gm_CodeError + 14)
    Gm_MissingEWord = (Gm_CodeError + 15)
    Gm_MissingHWord = (Gm_CodeError + 16)
    Gm_MissingDWord = (Gm_CodeError + 17)
    Gm_MissingTWord = (Gm_CodeError + 18)
    Gm_MissingAxisWord = (Gm_CodeError + 19)
    Gm_MissingSubAxisWord = (Gm_CodeError + 20)
    Gm_InvalidFValue = (Gm_CodeError + 21)
    Gm_InvalidSValue = (Gm_CodeError + 22)
    Gm_InvalidOValue = (Gm_CodeError + 23)
    Gm_InvalidNValue = (Gm_CodeError + 24)
    Gm_InvalidLValue = (Gm_CodeError + 25)
    Gm_InvalidPValue = (Gm_CodeError + 26)
    Gm_InvalidQValue = (Gm_CodeError + 27)
    Gm_InvalidRValue = (Gm_CodeError + 28)
    Gm_InvalidEValue = (Gm_CodeError + 29)
    Gm_InvalidHValue = (Gm_CodeError + 31)
    Gm_InvalidDValue = (Gm_CodeError + 32)
    Gm_InvalidTValue = (Gm_CodeError + 33)
    Gm_InvalidAxisValue = (Gm_CodeError + 34)
    Gm_InvalidSubAxisValue = (Gm_CodeError + 35)
    Gm_OverloadAxisNum = (Gm_CodeError + 36)
    Gm_InvalidAxisNumber = (Gm_CodeError + 37)
    Gm_MacroNotFound = (Gm_CodeError + 38)
    # Gm_SystemError
    Gm_InvalidGMSHandle = (Gm_SystemError + 1)
    Gm_InvalidThreadHandle = (Gm_SystemError + 2)
    Gm_SystemNotReady = (Gm_SystemError + 3)
    Gm_NotEnoughMemory = (Gm_SystemError + 4)
    Gm_InvalidPatternId = (Gm_SystemError + 5)
    Gm_InvalidBreakPoint = (Gm_SystemError + 6)
    Gm_InvalidMacroNumber = (Gm_SystemError + 7)
    Gm_CodeOverload = (Gm_SystemError + 8)
    Gm_MacroOverload = (Gm_SystemError + 9)
    Gm_InvalidFeedRate = (Gm_SystemError + 10)
    Gm_InvalidModuleRange = (Gm_SystemError + 11)
    Gm_RadiusCompensationAlreadyOn = (Gm_SystemError + 12)
    Gm_OverCut = (Gm_SystemError + 13)
    Gm_WrongRefPlane = (Gm_SystemError + 14)
    Gm_DllNotFound = (Gm_SystemError + 15)
    Gm_Ax_ErrorStop = (Gm_SystemError + 16)
    Gm_OverrunDwell = (Gm_SystemError + 17)
    Gm_InvalidSetCoordinate = (Gm_SystemError + 18)
    Gm_OverrunAxisNum = (Gm_SystemError + 19)
    Gm_InvalidG29 = (Gm_SystemError + 20)
    Gm_BothOfGCodeUseAxisWords= (Gm_SystemError + 21)
    Gm_NotFoundNext = (Gm_SystemError + 22)
    Gm_ArcAxisNumError = (Gm_SystemError + 23)
    Gm_OverrunContiAxis = (Gm_SystemError + 24)
    Gm_ContiArcAxisError = (Gm_SystemError + 25)
    Gm_G272829CanNotBeConti = (Gm_SystemError + 26)
    Gm_CheckHomeFailed = (Gm_SystemError + 27)
    Gm_StackOverflow = (Gm_SystemError + 28)
    Gm_StackUnderflow = (Gm_SystemError + 29)
    Gm_InvalidAxHomeMode = (Gm_SystemError + 30)
    Gm_OverrunFilePath = (Gm_SystemError + 31)
    Gm_OverrunLineText = (Gm_SystemError + 32)
    Gm_InvalidSSTA = (Gm_SystemError + 33)
    Gm_InfineLoop = (Gm_SystemError + 34)
    Gm_InvalidDoDevice = (Gm_SystemError + 35)
    Gm_InvalidDoChannel = (Gm_SystemError + 36)
    Gm_InvalidDoLevel = (Gm_SystemError + 37)
    Gm_InvalidDiDevice = (Gm_SystemError + 38)
    Gm_InvalidDiChannel = (Gm_SystemError + 39)
    Gm_InvalidDiLevel = (Gm_SystemError + 40)
    Gm_RunCustomMcodeError = (Gm_SystemError + 41)
    Gm_ZeroVector = (Gm_SystemError + 42)
    Gm_LineParallel = (Gm_SystemError + 43)
    Gm_InvalidBufferLength = (Gm_SystemError + 44)
    GmInvalidOptionPauseParam = (Gm_SystemError + 45)
    GmInvalidOptionSkip = (Gm_SystemError + 46)
    GmWaitDiTimeOut = (Gm_SystemError + 47)
    GmCannotInvokeMacroInMacro= (Gm_SystemError + 48)
    GmThreadTimeOut = (Gm_SystemError + 49)
    Gm_InvalidDiValue = (Gm_SystemError + 50)
    Gm_BeOverCutted = (Gm_SystemError + 51)
    Gm_RadiusCompensationCannotWithG2G3= (Gm_SystemError + 52)  
    Gm_InvalidPpointID = (Gm_SystemError + 53)  
    Gm_InvalidFilePath = (Gm_SystemError + 54)
    Gm_InvalidFileFormat = (Gm_SystemError + 55)
    Gm_PpointHasNotSet = (Gm_SystemError + 56) 
    Gm_PpointLenNotEqualWithAxesNum = (Gm_SystemError + 57)  
    Gm_PpointAndNonPCannotBeMixed = (Gm_SystemError + 58) 
    Gm_StartPosCannotEqualWithEndPos = (Gm_SystemError + 59) 
    Gm_InvalidBoolID = (Gm_SystemError + 60) 
    Gm_BoolHasNotSet = (Gm_SystemError + 61) 
    Gm_IfBlockNotCorrect = (Gm_SystemError + 62) 
    Gm_IfBlockFlowError = (Gm_SystemError + 63) 
    Gm_InvalidParameter = (Gm_SystemError + 64) 
    InvalidAxPPU = (ComponentError)
    InvalidAxPulseInMaxFreq = (ComponentError + 1)
    InvalidAxHomeCrossDistance = (ComponentError + 2)
    InvalidAxHomeExSwitchMode = (ComponentError + 3)
    InvalidAxOrgReact = (ComponentError + 4)
    InvalidAxBacklashVel = (ComponentError + 5)
    InvalidAxExtMasterSrc = (ComponentError + 6)
    InvalidAxExtSelEnable = (ComponentError + 7)
    InvalidAxExtPulseInMode = (ComponentError + 8)
    InvalidAxExtPulseNum = (ComponentError + 9)
    InvalidAxExtPresetNum = (ComponentError + 10)
    InvalidAxAuxOutEnable = (ComponentError + 11)
    InvalidAxAuxOutTime = (ComponentError + 12)
    InvalidAxGenDoEnable = (ComponentError + 13)
    InvalidAxCompareEnable = (ComponentError + 14)
    InvalidAxLatchEnable = (ComponentError + 15)
    InvalidAxIN1Enable = (ComponentError + 16)
    InvalidAxIN1Logic = (ComponentError + 17)
    InvalidAxIN1React = (ComponentError + 18)
    InvalidAxIN2Enable = (ComponentError + 19)
    InvalidAxIN2Logic = (ComponentError + 20)
    InvalidAxIN2React = (ComponentError + 21)
    InvalidAxIN4Enable = (ComponentError + 22)
    InvalidAxIN4Logic = (ComponentError + 23)
    InvalidAxIN4React = (ComponentError + 24)
    InvalidAxIN5Enable = (ComponentError + 25)
    InvalidAxIN5Logic = (ComponentError + 26)
    InvalidAxIN5React = (ComponentError + 27)
    InvalidAxLatchBufEnable = (ComponentError + 28)
    InvalidAxLatchBufMinDist = (ComponentError + 29)
    InvalidAxLatchBufEventNum = (ComponentError + 30)
    InvalidAxLatchBufSource = (ComponentError + 31)
    InvalidAxLatchBufAxisID = (ComponentError + 32)
    InvalidAxLatchBufEdge = (ComponentError + 33)
    InvalidAxHomeOffsetDistance= (ComponentError + 34)
    InvalidAxHomeOffsetVel = (ComponentError + 35)
    InvalidAxCmpPulseWidthEx = (ComponentError + 36)
    InvalidAxPelToleranceEnable = (ComponentError + 37)
    InvalidAxPelToleranceValue = (ComponentError + 38)
    InvalidAxMelToleranceEnable = (ComponentError + 39)
    InvalidAxMelToleranceValue = (ComponentError + 40)
    InvalidAxSwPelToleranceEnable = (ComponentError + 41)
    InvalidAxSwPelToleranceValue = (ComponentError + 42)
    InvalidAxSwMelToleranceEnable = (ComponentError + 43)
    InvalidAxSwMelToleranceValue = (ComponentError + 44)
    InvalidAxALMFilterTime = (ComponentError + 45)
    InvalidAxLMTPFilterTime = (ComponentError + 46)
    InvalidAxLMTNFilterTime = (ComponentError + 47)
    InvalidAxIN1FilterTime = (ComponentError + 48)
    InvalidAxIN2FilterTime = (ComponentError + 49)
    InvalidAxORGFilterTime = (ComponentError + 50)
    InvalidAxIN4FilterTime = (ComponentError + 51)
    InvalidAxIN5FilterTime = (ComponentError + 52)
    InvalidAxPPUDenominator = (ComponentError + 53)
    InvalidAxPulseOutReverse = (ComponentError + 54)
    InvalidAxGantryMaxDiffValue = (ComponentError + 55)
    InvalidAxJogVLTime = (ComponentError + 56)
    InvalidAxCamDOEnable = (ComponentError + 57)
    InvalidAxCamDOLogic = (ComponentError + 58)
    InvalidAxCamDOCmpSrc = (ComponentError + 59)
    InvalidAxCamDOMode = (ComponentError + 60)
    InvalidAxCamDODir = (ComponentError + 61)
    InvalidAxCamDOLoLimit = (ComponentError + 62)
    InvalidAxCamDOHiLimit = (ComponentError + 63)
    InvalidAxSimStartSource = (ComponentError + 64)
    InvalidAxPelLogic = (ComponentError + 65)
    InvalidAxMelLogic = (ComponentError + 66)
    InvalidMultiCmpDeviation = (ComponentError + 67)
    InvalidAxParJerkFactor = (ComponentError + 68)
    DialogNotOpen = (ComponentError + 201)
    WriteFileStreamFailed = (ComponentError + 202)
    FileNameIsNull = (ComponentError + 203)
    InvalidFileFormat = (ComponentError + 204)
    FileIsExisted = (ComponentError + 205)
    FileIsNotExists = (ComponentError + 206)
    InvalidDirectory = (ComponentError + 207)
    LoadDxfFileFailed = (ComponentError + 208)
    EC_GetNICNumberFailed = (ECTError)
    EC_GetNICInfoFailed	 = (ECTError + 1)
    EC_OpenMainDevFailed = (ECTError + 2)
    EC_GetSubDeviceFailed = (ECTError + 3)
    EC_StartOpModeFailed = (ECTError + 4)
    EC_CloseDeviceFailed = (ECTError + 5)
    EC_MemAllocateFailed = (ECTError + 6)
    EC_InvalidNicIndex = (ECTError + 7)
    EC_OpenDevFailed = (ECTError + 8)
    EC_ReadFileFailed = (ECTError + 9)
    EC_GetNicInfoFailed = (ECTError + 10)
    EC_GetSDOFailed = (ECTError + 11)
    EC_InvalidParameter = (ECTError + 12)
    EC_GetPDOOffsetFailed = (ECTError + 13)
    EC_InitialMappingInfoFalied= (ECTError + 14)
    EC_InitResourceFailed = (ECTError + 15)
    EC_SetSDOFailed = (ECTError + 16)
    EC_InvalidPortType = (ECTError + 17)
    EC_SetCycleTimeFailed = (ECTError + 18)
    EC_InvalidAoRange = (ECTError + 19)
    EC_InvalidAiRange = (ECTError + 20)
    EC_GetSubDeviceInfoFailed = (ECTError + 21)
    EC_GetNetWorkStateFaied = (ECTError + 22)
    EC_RegisterEventFailed = (ECTError + 23)
    EC_InvalidIntegrationTime= (ECTError + 24)
    EC_InvalidAIEnable = (ECTError + 25)
    EC_InvalidDIFilter = (ECTError + 26)
    EC_SetSubDeviceStateFailed = (ECTError + 27)
    EC_ZeroCalibrationFailed = (ECTError + 28)
    EC_InvalidMainHandle = (ECTError + 29)
    EC_InvalidENIFile = (ECTError + 30)
    EC_InvalidCaliType = (ECTError + 31)
    EC_SetCaliValueFailed = (ECTError + 32)
    EC_AOCalibrationFailed = (ECTError + 33)
    EC_InvalidIOMapping	= (ECTError + 34)
    EC_PortIndexGreaterThanPortNum = (ECTError + 35)
    EC_ChannelIDGreaterThanChannelNum = (ECTError + 36)
    EC_InputIndexGreaterThanInputNum = (ECTError + 37)
    EC_OutputIndexGreaterThanOutputNum = (ECTError + 38)
    EC_SetEnableFailed = (ECTError + 39)
    EC_SetAIRangeFailed = (ECTError + 40)
    EC_SetIntegrationTimeFailed = (ECTError + 41)
    EC_PropertyNotSupported = (ECTError + 42)
    EC_SubDeviceIDConflicted = (ECTError + 43)
    EC_SpanCalibrationFailed = (ECTError + 44)
    EC_InvalidAiValue = (ECTError + 45)
    EC_InvalidAoValue = (ECTError + 46)
    EC_GetModuleFailed = (ECTError + 47)
    EC_InvalidCntEnable = (ECTError + 48)
    EC_InvalidCntPulseInMode = (ECTError + 49)
    EC_InvalidCntInitValue = (ECTError + 50)
    EC_InvalidCntMaxValue = (ECTError + 51)
    EC_InvalidCntOverflowMode = (ECTError + 52)
    EC_InvalidCntLatchEnable = (ECTError + 53)
    EC_InvalidCntLatchEdge = (ECTError + 54)
    EC_InvalidCntCmpEnable = (ECTError + 55)
    EC_InvalidCntCmpMethod = (ECTError + 56)
    EC_InvalidCmpDoEnable = (ECTError + 57)
    EC_InvalidCmpDoOutputMode= (ECTError + 58)
    EC_InvalidCmpDoLogic = (ECTError + 59)
    EC_InvalidCmpDoPulseWidth= (ECTError + 60)
    EC_AxCntExceeded = (ECTError + 61)
    EC_FWUpgraded = (ECTError + 62)
    EC_InvalidCntPulseInLogic = (ECTError + 63)
    EC_InvalidCntPulseInMaxFreq = (ECTError + 64)
    EC_InvalidCntMultiCmpDeviation = (ECTError + 65)
    EC_InvalidAoEnable = (ECTError + 66)
    EC_InvalidDoEnable = (ECTError + 67)
    EC_InvalidCntLatchLogic = (ECTError + 68)
    EC_InvalidCmpDoLinkPulseIn = (ECTError + 69)
    EC_InvalidDoOutputMode = (ECTError + 70)
    EC_InvalidDoLogic = (ECTError + 71)
    EC_InvalidDoPulseWidth = (ECTError + 72)
    EC_InvalidDoDelayTime = (ECTError + 73)
    EC_InvalidDoLinkCmpDo = (ECTError + 74)
    EC_UnequalCmpDataNumbers = (ECTError + 75)
    ECAT_MainEcatError = (ECTDevError + 1)
    ECAT_SubDeviceDisconnect_R0 = (ECTDevError + 2)
    ECAT_SubDeviceDisconnect_R1 = (ECTDevError + 3)
    ECAT_R0_CHECK_OP_TIMEOUT = (ECTDevError + 4)
    ECAT_R0_INIT_TIMEOUT = (ECTDevError + 5)
    ECAT_R0_START_TIMEOUT = (ECTDevError + 6)
    ECAT_R0_GET_SUBDEVICE_ID_TIMEOUT = (ECTDevError + 7)
    ECAT_SubDeviceLostPDOArriveWarnThreshold_R0	= (ECTDevError + 8)
    ECAT_SubDeviceLostPDOArriveWarnThreshold_R1	= (ECTDevError + 9)
    ECAT_SubDeviceModeChange_R0 = (ECTDevError + 10)
    ECAT_SubDeviceModeChange_R1 = (ECTDevError + 11)
    ECAT_SubDeviceLostFrame_R0 = (ECTDevError + 12)
    ECAT_SubDeviceLostFrame_R1 = (ECTDevError + 13)
    ECAT_ReconnectError_R0 = (ECTDevError + 14)
    ECAT_ReconnectError_R1 = (ECTDevError + 15)
    ECAT_R1_CHECK_OP_TIMEOUT = (ECTDevError + 16)
    ECAT_R1_INIT_TIMEOUT = (ECTDevError + 17)
    ECAT_R1_START_TIMEOUT = (ECTDevError + 18)
    ECAT_R1_GET_SUBDEVICE_ID_TIMEOUT = (ECTDevError + 19)
    ECAT_R0_GET_DEVICE_TYPE_FAILED = (ECTDevError + 20)
    ECAT_R1_GET_DEVICE_TYPE_FAILED = (ECTDevError + 21)
    ECAT_SubDeviceCountNotMatch_R0 = (ECTDevError + 22)
    ECAT_SubDeviceCountNotMatch_R1 = (ECTDevError + 23)
    ECAT_MainDevice_NULL = (ECTDevError + 24)	
    ECAT_MainDevice_SCAN_BUSY = (ECTDevError + 25)
    ECAT_MainDevice_DOMAIN_FAILED = (ECTDevError + 26)
    ECAT_MainDevice_NOT_SUPPORT_SUBDEVICE = (ECTDevError + 27)
    ECAT_MainDevice_FAILED_TO_CONFIG_SUBDEVICE = (ECTDevError + 28)
    ECAT_MainDevice_FAILED_TO_CONFIG_SYNCMANAGER = (ECTDevError + 29)
    ECAT_MainDevice_FAILED_TO_ADD_PDO_MAPPING = (ECTDevError + 30)
    ECAT_MainDevice_FAILED_TO_REGISTER_PDO_ENTRY = (ECTDevError + 31)
    ECAT_MainDevice_ACTIVATE_FAILED = (ECTDevError + 32)
    ECAT_MainDevice_DOMAN_DATA_FAILED = (ECTDevError + 33)
    ECAT_MainDevice_TOO_MANY_AXES = (ECTDevError + 34)
    ECAT_MainDevice_NO_FIND_PDO = (ECTDevError + 35)
    ECAT_MainDevice_NO_FIND_ENI_FILE = (ECTDevError + 36)
    ECAT_MainDevice_ENI_LOAD_FAILED = (ECTDevError + 37)
    ECAT_MainDevice_ENI_NO_FIND_CONFIG = (ECTDevError + 38)
    ECAT_MainDevice_ENI_NO_FIND_CYCLIC = (ECTDevError + 39)
    ECAT_MainDevice_ENI_OVER_MAX_SUBDEVICES = (ECTDevError + 40)
    ECAT_MainDevice_ENI_CONFIG_FAILED = (ECTDevError + 41)
    ECAT_MainDevice_NO_ACTIVATE = (ECTDevError + 42)
    ECAT_MainDevice_IS_CONFIGURING_SUBDEICE = (ECTDevError + 43)
    ECAT_MainDevice_FAILED_TO_CREATE_REGISTER_REQ = (ECTDevError + 44)
    ECAT_MainDevice_FAILED_TO_CREATE_SDO_REQ = (ECTDevError + 45)
    # Toggle bit not changed
    ECAT_SDO_ToggleBitNotChanged = (ECTDevSDOError + 0x5300)
    # SDO protocol timeout
    ECAT_SDO_ProtocolTimeout = (ECTDevSDOError + 0x5400)
    # Client/Server command specifier not valid or unknown
    ECAT_SDO_CommandNotValidOrUnknown = (ECTDevSDOError + 0x5401)
    # Out of memory
    ECAT_SDO_OutOfMemory = (ECTDevSDOError + 0x5405)
    # Unsupported access to an object
    ECAT_SDO_UnsupportedAccess = (ECTDevSDOError + 0x6100)
    # Attempt to read a write-only object
    ECAT_SDO_WriteOnlyObject = (ECTDevSDOError + 0x6101)
    # Attempt to write a read-only object
    ECAT_SDO_ReadOnlyObject = (ECTDevSDOError + 0x6102)
    # This object does not exist in the object directory
    ECAT_SDO_ObjectNotExist = (ECTDevSDOError + 0x6200)
    # The object cannot be mapped into the PDO
    ECAT_SDO_MappedToPDOFailed= (ECTDevSDOError + 0x6441)
    # The number and length of the objects to be mapped would exceed the PDO length
    ECAT_SDO_ExceedPdoLength = (ECTDevSDOError + 0x6442)
    # General parameter incompatibility reason
    ECAT_SDO_ParameterIncompatibility = (ECTDevSDOError + 0x6443)
    # General internal incompatibility in device
    ECAT_SDO_InternalIncompatibility = (ECTDevSDOError + 0x6447)
    # Access failure due to a hardware error
    ECAT_SDO_HardwareError = (ECTDevSDOError + 0x6600)
    # Data type does not match length of service parameter does not match
    ECAT_SDO_LengthNotMatch = (ECTDevSDOError + 0x6710)
    # Data type does not match length of service parameter too high
    ECAT_SDO_LengthTooHigh = (ECTDevSDOError + 0x6712)
    # Data type does not match length of service parameter too low
    ECAT_SDO_LengthTooLow = (ECTDevSDOError + 0x6713)
    # Subindex does not exist
    ECAT_SDO_SubindexNotExist = (ECTDevSDOError + 0x6911)
    # Value range of parameter exceeded
    ECAT_SDO_ValueRangeExceeded = (ECTDevSDOError + 0x6930)
    # Value of parameter written too high
    ECAT_SDO_WrittenTooHigh = (ECTDevSDOError + 0x6931)
    # Value of parameter written too low
    ECAT_SDO_WrittenTooLow = (ECTDevSDOError + 0x6932)
    # Maximum value is less than minimum value
    ECAT_SDO_MaximumLessMinimum= (ECTDevSDOError + 0x6936)
    # General error
    ECAT_SDO_GeneralError = (ECTDevSDOError + 0x8000)
    # Data cannot be transferred or stored to the application
    ECAT_SDO_ErrorStoredToApplication = (ECTDevSDOError + 0x8020)
    # Data cannot be transferred or stored to the application because of local control
    ECAT_SDO_ErrorStoredOfLocalControl = (ECTDevSDOError + 0x8021)
    # Data cannot be transferred or stored to the application because of the present device state
    ECAT_SDO_ErrorStoredOfPresentDeviceState = (ECTDevSDOError + 0x8022)
    # Object dictionary dynamic generation fails or no object
    ECAT_SDO_DynamicGenerationFails	= (ECTDevSDOError + 0x8023)
    ECAT_MOTION_MAIN_NULL = (ECTMotionError + 1)
    ECAT_MOTION_SCAN_BUSY = (ECTMotionError + 2)
    ECAT_MOTION_DOMAIN_FAILED = (ECTMotionError + 3)
    ECAT_MOTION_SUBDEVICE_NOT_SUPPORT = (ECTMotionError + 4)
    ECAT_MOTION_SUBDEVICE_CONFIG_FAILED = (ECTMotionError + 5)
    ECAT_MOTION_ACTIVE_FAILED = (ECTMotionError + 6)
    ECAT_MOTION_DOMAN_DATA_FAILED = (ECTMotionError + 7)
    ECAT_MOTION_TOO_MANY_AXES = (ECTMotionError + 8)
    ECAT_MOTION_ALREADY_ACTIVE = (ECTMotionError + 9)
    ECAT_MOTION_SUBDEVICE_REG_ERR_ALIAS = (ECTMotionError + 10)
    ECAT_MOTION_SUBDEVICE_REG_ERR_SET_120 = (ECTMotionError + 11)
    ECAT_MOTION_SUBDEVICE_REG_ERR_GET_130 = (ECTMotionError + 12)
    ECAT_MOTION_SUBDEVICE_REG_ERR_GET_134 = (ECTMotionError + 13)
    ECAT_IO_MAIN_NULL = (ECTIOError + 1)
    ECAT_IO_SCAN_BUSY = (ECTIOError + 2)
    ECAT_IO_DOMAIN_FAILED = (ECTIOError + 3)
    ECAT_IO_SUBDEVICE_NOT_SUPPORT = (ECTIOError + 4)
    ECAT_IO_SUBDEVICE_CONFIG_FAILED	= (ECTIOError + 5)
    ECAT_IO_ACTIVE_FAILED = (ECTIOError + 6)
    ECAT_IO_DOMAN_DATA_FAILED = (ECTIOError + 7)
    ECAT_IO_SUBDEVICE_RESCAN = (ECTIOError + 8)
    ECAT_AxRetryError = (ECTAxError + 1)
    ECAT_AxResetCounterError = (ECTAxError + 2)
    ECAT_AxCmdErrorProtection = (ECTAxError + 3)
    ECAT_AxSubDeviceALM = (ECTAxError + 4)
    ECAT_AxFollowError = (ECTAxError + 5)
    ECAT_AxHomeError = (ECTAxError + 6)
    ECAT_AxSubDeviceStateChanged = (ECTAxError + 7)
    ECAT_AxSubDeviceDoNotReady = (ECTAxError + 8)
    # Error from CiA402 ecat driver
    ECTAxOPERATIONMODE = (ECTAxError + 0x10)
    ECAT_HM_OPMODE_ProtocolTimeout = (ECTAxOPERATIONMODE + 1)
    ECAT_HM_OPMODE_ObjectNotExist = (ECTAxOPERATIONMODE + 2)
    ECAT_HM_OPMODE_SubindexNotExist	= (ECTAxOPERATIONMODE + 3)
    ECAT_HM_OPMODE_ValueRangeExceeded = (ECTAxOPERATIONMODE + 4)
    ECAT_HM_OPMODE_WrittenTooHigh = (ECTAxOPERATIONMODE + 5)
    ECAT_HM_OPMODE_WrittenTooLow = (ECTAxOPERATIONMODE + 6)
    ECAT_HM_OPMODE_MaximumLessMinimum = (ECTAxOPERATIONMODE + 7)
    ECAT_HM_OPMODE_OTHER = (ECTAxOPERATIONMODE + 8)
    # Error from CiA402 ecat driver
    ECTAxHOMEOFFSET = (ECTAxError + 0x20)
    ECAT_HM_OFFSET_ProtocolTimeout = (ECTAxHOMEOFFSET + 1)
    ECAT_HM_OFFSET_ObjectNotExist = (ECTAxHOMEOFFSET + 2)
    ECAT_HM_OFFSET_SubindexNotExist	= (ECTAxHOMEOFFSET + 3)
    ECAT_HM_OFFSET_ValueRangeExceeded = (ECTAxHOMEOFFSET + 4)
    ECAT_HM_OFFSET_WrittenTooHigh = (ECTAxHOMEOFFSET + 5)
    ECAT_HM_OFFSET_WrittenTooLow = (ECTAxHOMEOFFSET + 6)
    ECAT_HM_OFFSET_MaximumLessMinimum = (ECTAxHOMEOFFSET + 7)
    ECAT_HM_OFFSET_OTHER = (ECTAxHOMEOFFSET + 8)	
    # Error from CiA402 ecat driver
    ECTAxHOMEMODE = (ECTAxError + 0x30)
    ECAT_HM_MODE_ProtocolTimeout = (ECTAxHOMEMODE + 1)
    ECAT_HM_MODE_ObjectNotExist = (ECTAxHOMEMODE + 2)
    ECAT_HM_MODE_SubindexNotExist = (ECTAxHOMEMODE + 3)
    ECAT_HM_MODE_ValueRangeExceeded	= (ECTAxHOMEMODE + 4)
    ECAT_HM_MODE_WrittenTooHigh = (ECTAxHOMEMODE + 5)
    ECAT_HM_MODE_WrittenTooLow = (ECTAxHOMEMODE + 6)
    ECAT_HM_MODE_MaximumLessMinimum	= (ECTAxHOMEMODE + 7)
    ECAT_HM_MODE_OTHER = (ECTAxHOMEMODE + 8)
    # Error from CiA402 ecat driver
    ECTAxHOMEINT = (ECTAxError + 0x40)
    ECAT_HM_INTERNAL_SetModeTimeout	= (ECTAxHOMEINT + 1)
    ECAT_HM_INTERNAL_WaitStateTimeout = (ECTAxHOMEINT + 2)
    ECAT_HM_INTERNAL_WaitDoneFaultBit = (ECTAxHOMEINT + 3)
    ECAT_HM_INTERNAL_WaitDoneServoOff = (ECTAxHOMEINT + 4)
    ECAT_HM_INTERNAL_WaitDoneError = (ECTAxHOMEINT + 5)
    ECAT_HM_INTERNAL_WaitDoneDefault = (ECTAxHOMEINT + 6)
    ENET_Client_SendDevCtrlFail = (ENETClientError + 1)
    ENET_Client_ReceiveDevCtrlFail = (ENETClientError + 2)
    ENET_Client_CloseSocketFail = (ENETClientError + 3)
    ENET_Client_DnldUpgrade_FirstRequestFail = (ENETClientError + 4)
    ENET_Client_DnldUpgrade_SendFileFail = (ENETClientError + 5)
    ENET_Client_DnldUpgrade_FinishRequestFail = (ENETClientError + 6)
    ENET_Client_DnldUpgrade_ServerResponseFail = (ENETClientError + 7)
    ENET_Client_DnldUpgrade_ExecutionFail = (ENETClientError + 8)
    ENET_Client_ImNetwork_FirstRequestFail = (ENETClientError + 9)
    ENET_Client_ImNetwork_SendFileFail = (ENETClientError + 10)
    ENET_Client_ImNetwork_FinishRequestFail = (ENETClientError + 11)
    ENET_Client_ImNetwork_ServerResponseFail = (ENETClientError + 12)
    ENET_Client_ImNetwork_ExecutionFail = (ENETClientError + 13)
    ENET_Client_ImConfig_FirstRequestFail = (ENETClientError + 14)
    ENET_Client_ImConfig_SendFileFail = (ENETClientError + 15)
    ENET_Client_ImConfig_FinishRequestFail = (ENETClientError + 16)
    ENET_Client_ImConfig_ServerResponseFail = (ENETClientError + 17)
    ENET_Client_ImConfig_ExecutionFail = (ENETClientError + 18)
    ENET_Client_ExNetwork_FirstRequestFail = (ENETClientError + 19)
    ENET_Client_ExNetwork_DatasizeIncorrect = (ENETClientError + 20)
    ENET_Client_ExNetwork_ReceiveFileFail = (ENETClientError + 21)
    ENET_Client_ExNetwork_FinishRequestFail = (ENETClientError + 22)
    ENET_Client_ExNetwork_ServerResponseFail = (ENETClientError + 23)
    ENET_Client_ExConfig_FirstRequestFail = (ENETClientError + 24)
    ENET_Client_ExConfig_DatasizeIncorrect = (ENETClientError + 25)
    ENET_Client_ExConfig_ReceiveFileFail = (ENETClientError + 26)
    ENET_Client_ExConfig_FinishRequestFail = (ENETClientError + 27)
    ENET_Client_ExConfig_ServerResponseFail = (ENETClientError + 28)
    ENET_Client_ExConfig_FileNameToolong = (ENETClientError + 29)
    ENET_Client_SendDevParsFail = (ENETClientError + 30)
    ENET_Client_ReceiveDevParsFail = (ENETClientError + 32)
    ENET_Client_GetDnldAresName_FirstRequestFail = (ENETClientError + 33)
    ENET_Client_GetDnldAresName_ReceiveNameFail = (ENETClientError + 34)
    ENET_Client_LoadAresProgram_FileNameToolong = (ENETClientError + 35)
    ENET_Client_LoadAresProgram_SendNameFail = (ENETClientError + 36)
    ENET_Client_LoadAresProgram_FinishRequestFail = (ENETClientError + 37)
    ENET_Client_LoadAresProgram_ServerResponseFail = (ENETClientError + 38)
    ENET_Client_LoadAresProgram_ExecutionFail = (ENETClientError + 39)
    ENET_Client_WriteAresProgram_FileNameToolong = (ENETClientError + 40)
    ENET_Client_WriteAresProgram_SendNameFail = (ENETClientError + 41)
    ENET_Client_WriteAresProgram_FinishRequestFail = (ENETClientError + 42)
    ENET_Client_WriteAresProgram_ServerResponseFail = (ENETClientError + 43)
    ENET_Client_WriteAresProgram_ExecutionFail = (ENETClientError + 44)
    ENET_Client_AxGetInfo_FirstRequestFail = (ENETClientError + 45)
    ENET_Client_AxGetInfo_ReceiveDataFail = (ENETClientError + 46)
    ENET_Client_SendAxCtrlFail = (ENETClientError + 47)
    ENET_Client_ReceiveAxCtrlFail = (ENETClientError + 48)
    ENET_Client_GetRunningAresName_FileNameToolong = (ENETClientError + 49)
    ENET_Client_GetAresErrorMsg_FileNameToolong = (ENETClientError + 50)
    ENET_Client_GetAresErrorMsg_ErrMsgToolong = (ENETClientError + 51)
    # Low 2 bytes(0xXXXX)為Windows Socket通用錯誤空間
    ENET_Client_WSAStartError = (ENETClientError + 0x10000)
    ENET_Client_CreatSocketError = (ENETClientError + 0x20000)
    # Low 2 bytes(0xXXXX)為Windows Socket通用錯誤空間
    ENET_Client_SetSocketSendTimeoutError = (ENETClientError + 0x30000)
    ENET_Client_SetSocketReceiveTimeoutError = (ENETClientError + 0x40000)
    ENET_Client_IPdataError = (ENETClientError + 0x50000)
    ENET_Client_ConnectError = (ENETClientError + 0x60000)
    ENET_Server_XXXX = (ENETServerError + 0x10000)

class ErrorCode(IntEnum):
    SUCCESS = 0x00000000
    Warning = 0x10000000
    FuncError = 0x80000000
    CommError = 0x80001000
    MotionError = 0x80002000
    DaqError = 0x80003000
    DevEvtError = 0x80004000
    DspError = 0x80005000
    DspAxError = 0x80005100
    DspGpError = 0x80005200
    DspRbError = 0x80005500
    ECTError = 0x83000000
    # EtherCAT master & slave error
    ECTDevError = 0x83010000
    # Error from SDO communication 0x8301 XXXX
    ECTDevSDOError = 0x83020000
    # Error from Motion port communication
    ECTMotionError = 0x83030000
    # Error from IO port communication
    ECTIOError = 0x83040000
    # Error from CiA402 ecat driver
    ECTAxError = 0x83050000
    # Error from Motion port communication
    ECTMotionConnError = 0x83060000
    # Error from IO port communication
    ECTIOConnError = 0x83070000
    # EtherCAT Drive error
    ECAT_DriveError = 0x83100000
    ECAT_MotionConnStatus = 0x84000000
    ECAT_IoConnStatus = 0x85000000
    # Function error
    InvalidDevNumber = (FuncError + 0)
    DevRegDataLost = (FuncError + 1)
    LoadDllFailed = (FuncError + 2)
    GetProcAddrFailed = (FuncError + 3)
    MemAllocateFailed = (FuncError + 4)
    InvalidHandle = (FuncError + 5)
    CreateFileFailed = (FuncError + 6)
    OpenEventFailed = (FuncError + 7)
    EventTimeOut = (FuncError + 8)
    InvalidInputParam = (FuncError + 9)
    PropertyIDNotSupport = (FuncError + 10)
    PropertyIDReadOnly = (FuncError + 11)
    ConnectWinIrqFailed = (FuncError + 12)
    InvalidAxCfgVel = (FuncError + 13)
    InvalidAxCfgAcc = (FuncError + 14)
    InvalidAxCfgDec = (FuncError + 15)
    InvalidAxCfgJerk = (FuncError + 16)
    InvalidAxParVelLow = (FuncError + 17)
    InvalidAxParVelHigh = (FuncError + 18)
    InvalidAxParAcc = (FuncError + 19)
    InvalidAxParDec = (FuncError + 20)
    InvalidAxParJerk = (FuncError + 21)
    InvalidAxPulseInMode = (FuncError + 22)
    InvalidAxPulseOutMode = (FuncError + 23)
    InvalidAxAlarmEn = (FuncError + 24)
    InvalidAxAlarmLogic = (FuncError + 25)
    InvalidAxInPEn = (FuncError + 26)
    InvalidAxInPLogic = (FuncError + 27)
    InvalidAxHLmtEn = (FuncError + 28)
    InvalidAxHLmtLogic = (FuncError + 29)
    InvalidAxHLmtReact = (FuncError + 30)
    InvalidAxSLmtPEn = (FuncError + 31)
    InvalidAxSLmtPReact = (FuncError + 32)
    InvalidAxSLmtPValue = (FuncError + 33)
    InvalidAxSLmtMEn = (FuncError + 34)
    InvalidAxSLmtMReact = (FuncError + 35)
    InvalidAxSLmtMValue = (FuncError + 36)
    InvalidAxOrgLogic = (FuncError + 37)
    InvalidAxOrgEnable = (FuncError + 38)
    InvalidAxEzLogic = (FuncError + 39)
    InvalidAxEzEnable = (FuncError + 40)
    InvalidAxEzCount = (FuncError + 41)
    InvalidAxState = (FuncError + 42)
    InvalidAxInEnable = (FuncError + 43)
    InvalidAxSvOnOff = (FuncError + 44)
    InvalidAxDistance = (FuncError + 45)
    InvalidAxPosition = (FuncError + 46)
    InvalidAxHomeModeKw = (FuncError + 47)
    InvalidAxCntInGp = (FuncError + 48)
    AxInGpNotFound = (FuncError + 49)
    AxIsInOtherGp = (FuncError + 50)
    AxCannotIntoGp = (FuncError + 51)
    GpInDevNotFound = (FuncError + 52)
    InvalidGpCfgVel = (FuncError + 53)
    InvalidGpCfgAcc = (FuncError + 54)
    InvalidGpCfgDec = (FuncError + 55)
    InvalidGpCfgJerk = (FuncError + 56)
    InvalidGpParVelLow = (FuncError + 57)
    InvalidGpParVelHigh = (FuncError + 58)
    InvalidGpParAcc = (FuncError + 59)
    InvalidGpParDec = (FuncError + 60)
    InvalidGpParJerk = (FuncError + 61)
    JerkNotSupport = (FuncError + 62)
    ThreeAxNotSupport = (FuncError + 63)
    DevIpoNotFinished = (FuncError + 64)
    InvalidGpState = (FuncError + 65)
    OpenFileFailed = (FuncError + 66)
    InvalidPathCnt = (FuncError + 67)
    InvalidPathHandle = (FuncError + 68)
    InvalidPath = (FuncError + 69)
    IoctlError = (FuncError + 70)
    AmnetRingUsed = (FuncError + 71)
    DeviceNotOpened = (FuncError + 72)
    InvalidRing = (FuncError + 73)
    InvalidSlaveIP = (FuncError + 74)
    InvalidParameter = (FuncError + 75)
    InvalidGpCenterPosition = (FuncError + 76)
    InvalidGpEndPosition = (FuncError + 77)
    InvalidAddress = (FuncError + 78)
    DeviceDisconnect = (FuncError + 79)
    DataOutBufExceeded = (FuncError + 80)
    SlaveDeviceNotMatch = (FuncError + 81)
    SlaveDeviceError = (FuncError + 82)
    SlaveDeviceUnknow = (FuncError + 83)
    FunctionNotSupport = (FuncError + 84)
    InvalidPhysicalAxis = (FuncError + 85)
    InvalidVelocity = (FuncError + 86)
    InvalidAxPulseInLogic = (FuncError + 87)
    InvalidAxPulseInSource = (FuncError + 88)
    InvalidAxErcLogic = (FuncError + 89)
    InvalidAxErcOnTime = (FuncError + 90)
    InvalidAxErcOffTime = (FuncError + 91)
    InvalidAxErcEnableMode = (FuncError + 92)
    InvalidAxSdEnable = (FuncError + 93)
    InvalidAxSdLogic = (FuncError + 94)
    InvalidAxSdReact = (FuncError + 95)
    InvalidAxSdLatch = (FuncError + 96)
    InvalidAxHomeResetEnable = (FuncError + 97)
    InvalidAxBacklashEnable = (FuncError + 98)
    InvalidAxBacklashPulses = (FuncError + 99)
    InvalidAxVibrationEnable = (FuncError + 100)
    InvalidAxVibrationRevTime = (FuncError + 101)
    InvalidAxVibrationFwdTime = (FuncError + 102)
    InvalidAxAlarmReact = (FuncError + 103)
    InvalidAxLatchLogic = (FuncError + 104)
    InvalidFwMemoryMode = (FuncError + 105)
    InvalidConfigFile = (FuncError + 106)
    InvalidAxEnEvtArraySize = (FuncError + 107)
    InvalidAxEnEvtArray = (FuncError + 108)
    InvalidGpEnEvtArraySize = (FuncError + 109)
    InvalidGpEnEvtArray = (FuncError + 110)
    InvalidIntervalData = (FuncError + 111)
    InvalidEndPosition = (FuncError + 112)
    InvalidAxisSelect = (FuncError + 113)
    InvalidTableSize = (FuncError + 114)
    InvalidGpHandle = (FuncError + 115)
    InvalidCmpSource = (FuncError + 116)
    InvalidCmpMethod = (FuncError + 117)
    InvalidCmpPulseMode = (FuncError + 118)
    InvalidCmpPulseLogic = (FuncError + 119)
    InvalidCmpPulseWidth = (FuncError + 120)
    InvalidPathFunctionID = (FuncError + 121)
    SysBufAllocateFailed = (FuncError + 122)
    SpeedFordFunNotSupported = (FuncError + 123)
    InvalidNormVector = (FuncError + 124)
    InvalidCmpTimeTableCount = (FuncError + 125)
    InvalidCmpTime = (FuncError + 126)
    FWDownLoading = (FuncError + 127)
    FWVersionNotMatch = (FuncError + 128)
    InvalidAxParHomeVelLow = (FuncError + 129)
    InvalidAxParHomeVelHigh = (FuncError + 130)
    InvalidAxParHomeAcc = (FuncError + 131)
    InvalidAxParHomeDec = (FuncError + 132)
    InvalidAxParHomeJerk = (FuncError + 133)
    InvalidAxCfgJogVelLow = (FuncError + 134)
    InvalidAxCfgJogVelHigh = (FuncError + 135)
    InvalidAxCfgJogAcc = (FuncError + 136)
    InvalidAxCfgJogDec = (FuncError + 137)
    InvalidAxCfgJogJerk = (FuncError + 138)
    InvalidAxCfgKillDec = (FuncError + 139)
    NotOpenAllAxes = (FuncError + 140)
    NotSetServoComPort = (FuncError + 141)
    OpenComPortFailed = (FuncError + 142)
    ReadComPortTimeOut = (FuncError + 143)
    SetComPortStateFailed = (FuncError + 144)
    SevroTypeNotSupport = (FuncError + 145)
    ReadComBufFailed = (FuncError + 146)
    InvalidAxMaxErrorCnt = (FuncError + 147)
    MoveModeNosupportBlend = (FuncError + 148)
    CmpModeCannotGenDO = (FuncError + 149)
    # AMONet Communication error
    SlaveIOUpdateError = (FuncError + 150)
    NoSlaveDevFound = (FuncError + 151)
    MasterDevNotOpen = (FuncError + 152)
    MasterRingNotOpen = (FuncError + 153)
    CannotFindCenterby3P = (FuncError + 154)
    InvalidAxCfgJogPAssign = (FuncError + 155)
    InvalidAxCfgJogNAssign = (FuncError + 156)
    InvalidAxCfgCamDOAssign = (FuncError + 157)
    InvalidAxCfgDIStopAssign = (FuncError + 158)
    PDONotAssign = (FuncError + 159)
    GpHadBeenModified = (FuncError + 160)
    PDOReadOnlyObject = (FuncError + 161)
    OpenFileSizeFailed = (FuncError + 162)
    OpenFilePathFailed = (FuncError + 163)
    InvalidFileName = (FuncError + 164)
    # DAQ function
    InvalidDIPort = (FuncError + 200)
    InvalidDOPort = (FuncError + 201)
    InvalidDOValue = (FuncError + 202)
    # EVT function
    CreateEventFailed = (FuncError + 203)
    CreateThreadFailed = (FuncError + 204)
    InvalidHomeModeEx = (FuncError + 205)
    InvalidDirMode = (FuncError + 206)
    AxHomeMotionFailed = (FuncError + 207)
    ReadFileFailed = (FuncError + 208)
    PathBufIsFull = (FuncError + 209)
    PathBufIsEmpty = (FuncError + 210)
    GetAuthorityFailed = (FuncError + 211)
    GpIDAllocatedFailed = (FuncError + 212)
    FirmWareDown = (FuncError + 213)
    InvalidGpRadius = (FuncError + 214)
    InvalidAxCmd = (FuncError + 215)
    InvalidAxExtDrv = (FuncError + 216)
    InvalidGpMovCmd = (FuncError + 217)
    SpeedCurveNotSupported = (FuncError + 218)
    InvalidCounterNo = (FuncError + 219)
    InvalidPathMoveMode = (FuncError + 220)
    PathSelStartCantRunInSpeedForwareMode = (FuncError + 221)
    InvalidCamTableID = (FuncError + 222)
    InvalidCamPointRange = (FuncError + 223)
    CamTableIsEmpty = (FuncError + 224)
    InvalidPlaneVector = (FuncError + 225)
    MasAxIDSameSlvAxID = (FuncError + 226)
    InvalidGpRefPlane = (FuncError + 227)
    InvalidAxModuleRange = (FuncError + 228)
    DownloadFileFailed = (FuncError + 229)
    InvalidFileLength = (FuncError + 230)
    InvalidCmpCnt = (FuncError + 231)
    JerkExceededMaxValue = (FuncError + 232)
    AbsMotionNotSupport = (FuncError + 233)
    InvalidAiRange = (FuncError + 234)
    AIScaleFailed = (FuncError + 235)
    AxInRobot = (FuncError + 236)
    Invalid3DArcFlat = (FuncError + 237)
    InvalidIpoMap = (FuncError + 238)
    DataSizeNotCorrect = (FuncError + 239)
    AxisNotFound = (FuncError + 240)
    InvalidPathVelHigh = (FuncError + 241)
    InvalidRbParVelLow = (FuncError + 250)
    InvalidRbParVelHigh = (FuncError + 251)
    InvalidRbParAcc = (FuncError + 252)
    InvalidRbParDec = (FuncError + 253)
    InvalidRbParJerk = (FuncError + 254)
    InvalidRbState = (FuncError + 255)
    InvalidRbHandle = (FuncError + 256)
    InvalidRbRadius = (FuncError + 257)
    InvalidRbMovCmd = (FuncError + 258)
    NotOpenRobot = (FuncError + 259)
    InvalidRbPoint = (FuncError + 260)
    RbAngleExceeded = (FuncError + 261)
    GetDIOFailed = (FuncError + 300)
    InvalidRingBufferCmd = (FuncError + 301)
    InvalidAoRange = (FuncError + 302)
    RingBufferOverFlow = (FuncError + 303)
    RbAreaExceeded = (FuncError + 304)
    InvalidAiValue = (FuncError + 305)
    InvalidAoValue = (FuncError + 306)
    NoPreScanData = (FuncError + 307)
    GroupNotAssigned = (FuncError + 308)
    AxisNotOpened = (FuncError + 309)
    DataCntExceeded = (FuncError + 310)
    InvalidCamTable = (FuncError + 311)
    CompareIntervalorPartsCalcuFail = (FuncError + 312)
    CmpIntervalorPartsExceedMax = (FuncError + 313)
    LinkObjectNotAssigned = (FuncError + 314)
    # Motion error
    HLmtPExceeded = (MotionError + 0)
    HLmtNExceeded = (MotionError + 1)
    SLmtPExceeded = (MotionError + 2)
    SLmtNExceeded = (MotionError + 3)
    AlarmHappened = (MotionError + 4)
    EmgHappened = (MotionError + 5)
    TimeLmtExceeded = (MotionError + 6)
    DistLmtExceeded = (MotionError + 7)
    InvalidPositionOverride = (MotionError + 8)
    OperationErrorHappened = (MotionError + 9)
    SimultaneousStopHappened = (MotionError + 10)
    OverflowInPAPB = (MotionError + 11)
    OverflowInIPO = (MotionError + 12)
    STPHappened = (MotionError + 13)
    SDHappened = (MotionError + 14)
    AxisNoCmpDataLeft = (MotionError + 15)
    # Device event error
    DevEvtTimeOut = (DevEvtError + 1)
    DevNoEvt = (DevEvtError + 2)
    # Warning
    Warning_AxWasInGp = (Warning + 1)
    # inconsistent rate of PPU setting
    Warning_GpInconsistRate = (Warning + 2)
    Warning_GpInconsistPPU = (Warning + 3)
    Warning_GpMoveDistanceCanntBeZero = (Warning + 4)
    Warning_GpExisted = (Warning + 5)
    Warning_DataNotYetProcessed = (Warning + 6)
    # Dsp error
    ERR_SYS_TIME_OUT = (DspError + 0x01)
    Dsp_PropertyIDNotSupport = (DspError + 0x02)
    Dsp_PropertyIDReadOnly = (DspError + 0x03)
    Dsp_InvalidParameter = (DspError + 0x04)
    Dsp_DataOutBufExceeded = (DspError + 0x05)
    Dsp_FunctionNotSupport = (DspError + 0x06)
    Dsp_InvalidConfigFile = (DspError + 0x07)
    Dsp_InvalidIntervalData = (DspError + 0x08)
    Dsp_InvalidTableSize = (DspError + 0x09)
    Dsp_InvalidTableID = (DspError + 0x0a)
    Dsp_DataIndexExceedBufSize = (DspError + 0x0b)
    Dsp_InvalidCompareInterval = (DspError + 0x0c)
    Dsp_InvalidCompareRange = (DspError + 0x0d)
    Dsp_PropertyIDWriteOnly = (DspError + 0x0e)
    Dsp_NcError = (DspError + 0x0f)	
    Dsp_CamTableIsInUse = (DspError + 0x10)	
    Dsp_EraseBlockFailed = (DspError + 0x11)	
    Dsp_ProgramFlashFailed = (DspError + 0x12)	
    Dsp_WatchdogError = (DspError + 0x13)	
    Dsp_ReadPrivateOverMaxTimes = (DspError + 0x14)
    Dsp_InvalidPrivateID = (DspError + 0x15)
    Dsp_DataNotReady = (DspError + 0x16)
    Dsp_LastOperationNotOver = (DspError + 0x17)
    Dsp_WritePrivateTimeout = (DspError + 0x18)
    Dsp_FwIsDownloading = (DspError + 0x19)
    Dsp_FwDownloadStepError = (DspError + 0x20)
    Dsp_InvalidDiLtcChannelID = (DspError + 0x21)
    Dsp_InvalidDoCmpChannelID = (DspError + 0x22)
    Dsp_InvalidDevPptValue = (DspError + 0x23)
    Dsp_CmpCannotLinkMultiLtc = (DspError + 0x24)
    Dsp_SDIOLinkError = (DspError + 0x25)
    InvalidVerScanTable = (DspError + 0x26) 
    InvalidVerEnablePos = (DspError + 0x27) 
    VerMovLimitExceeded = (DspError + 0x28)
    Dsp_InvalidTableName = (DspError + 0x29)
    Dsp_SlaveDoNotSupportSDO = (DspError + 0x2a) 
    Dsp_InvalidForceTrigger = (DspError + 0x2b)
    Dsp_MIOInvalidSer = (DspError + 0x30)
    Dsp_SDIInvalidSer = (DspError + 0x31)
    Plink_SynTimeTooShort = (DspError + 0x32)
    Dsp_LinkObjectExisted = (DspError + 0x33)
    Dsp_InvalidLatchChannelIsUsed = (DspError + 0x34)
    Dsp_InvalidLtcchannelOnlyUseOne = (DspError + 0x35)
    Dsp_InvalidSoftAxisID = (DspError + 0x36)
    Dsp_InvalidAxisIsNotSetByLatch = (DspError + 0x37)
    Dsp_InvalidLatchAxisIsNotLocal = (DspError + 0x38)
    Dsp_InvalidCmpchannelOnlyUseOne = (DspError + 0x39)
    Dsp_InvalidCmpAxisisUsedByOtherCh = (DspError + 0x3a)
    Dsp_InvalidSetPwmChannel = (DspError + 0x3b)
    Dsp_InvalidPwmChannelIsUsed = (DspError + 0x3c)
    Dsp_InvalidPwmchannelOnlyUseOne = (DspError + 0x3d)
    Dsp_MotionAPResetUnknown = (DspError + 0x3e)
    Dsp_MotionAPResetZero = (DspError + 0x3f)
    Dsp_MotionAPResetNormalError = (DspError + 0x40)
    Dsp_MotionAPResetSegfault = (DspError + 0x41)
    Dsp_MotionAPResetAbnormal = (DspError + 0x42)
    # Axis fw error
    Dsp_InvalidAxCfgVel = (DspAxError + 0x01)
    Dsp_InvalidAxCfgAcc = (DspAxError + 0x02)
    Dsp_InvalidAxCfgDec = (DspAxError + 0x03)
    Dsp_InvalidAxCfgJerk = (DspAxError + 0x04)
    Dsp_InvalidAxParVelLow = (DspAxError + 0x05)
    Dsp_InvalidAxParVelHigh = (DspAxError + 0x06)
    Dsp_InvalidAxParAcc = (DspAxError + 0x07)
    Dsp_InvalidAxParDec = (DspAxError + 0x08)
    Dsp_InvalidAxParJerk = (DspAxError + 0x09)
    Dsp_InvalidAxPptValue = (DspAxError + 0x0a)
    Dsp_InvalidAxState = (DspAxError + 0x0b)
    Dsp_InvalidAxSvOnOff = (DspAxError + 0x0c)
    Dsp_InvalidAxDistance = (DspAxError + 0x0d)
    Dsp_InvalidAxPosition = (DspAxError + 0x0e)
    Dsp_InvalidAxHomeMode = (DspAxError + 0x0f)
    Dsp_InvalidPhysicalAxis = (DspAxError + 0x10)
    Dsp_HLmtPExceeded = (DspAxError + 0x11)
    Dsp_HLmtNExceeded = (DspAxError + 0x12)
    Dsp_SLmtPExceeded = (DspAxError + 0x13)
    Dsp_SLmtNExceeded = (DspAxError + 0x14)
    Dsp_AlarmHappened = (DspAxError + 0x15)
    Dsp_EmgHappened = (DspAxError + 0x16)
    Dsp_CmdValidOnlyInConstSec = (DspAxError + 0x17)
    Dsp_InvalidAxCmd = (DspAxError + 0x18)
    Dsp_InvalidAxHomeDirMode = (DspAxError + 0x19)
    Dsp_AxisMustBeModuloAxis = (DspAxError + 0x1a)
    Dsp_AxIdCantSameAsMasId = (DspAxError + 0x1b)
    Dsp_CantResetPosiOfMasAxis = (DspAxError + 0x1c)
    Dsp_InvalidAxExtDrvOperation = (DspAxError + 0x1d)
    Dsp_AxAccExceededMaxAcc = (DspAxError + 0x1e)
    Dsp_AxVelExceededMaxVel = (DspAxError + 0x1f)
    Dsp_NotEnoughPulseForChgV = (DspAxError + 0x20)
    Dsp_NewVelMustGreaterThanVelLow = (DspAxError + 0x21)
    Dsp_InvalidAxGearMode = (DspAxError + 0x22)
    Dsp_InvalidGearRatio = (DspAxError + 0x23)
    Dsp_InvalidPWMDataCount = (DspAxError	+ 0x24)
    Dsp_InvalidAxPWMFreq = (DspAxError	+ 0x25)
    Dsp_InvalidAxPWMDuty = (DspAxError	+ 0x26)
    Dsp_AxGantryExceedMaxDiffValue = (DspAxError + 0x27)
    Dsp_ChannelIsDisable = (DspAxError + 0x28)
    Dsp_ChannelBufferIsFull = (DspAxError + 0x29)
    Dsp_ChannelBufferIsEmpty = (DspAxError + 0x30)
    Dsp_InvalidDoChannelID = (DspAxError + 0x31)
    Dsp_LatchHappened = (DspAxError + 0x32)
    Dsp_InvalidAxKillDec = (DspAxError + 0x33)
    Dsp_InvalidAxJogVelLow = (DspAxError + 0x34)
    Dsp_InvalidAxJogVelHigh = (DspAxError + 0x35)
    Dsp_InvalidAxJogAcc = (DspAxError + 0x36)
    Dsp_InvalidAxJogDec = (DspAxError + 0x37)
    Dsp_InvalidAxJogJerk = (DspAxError + 0x38)
    Dsp_InvalidAxHomeVelLow = (DspAxError + 0x39)
    Dsp_InvalidAxHomeVelHigh = (DspAxError + 0x40)
    Dsp_InvalidAxHomeAcc = (DspAxError + 0x41)
    Dsp_InvalidAxHomeDec = (DspAxError + 0x42)
    Dsp_InvalidAxHomeJerk = (DspAxError + 0x43)
    Dsp_PosErrorCntExceed = (DspAxError + 0x44)
    Dsp_InvalidAxCounterMax = (DspAxError + 0x45)
    Dsp_InvalidAxOverflowMode = (DspAxError + 0x46)
    Dsp_ImposeTimeLongerPTP = (DspAxError + 0x47)
    Dsp_AxAngExceededMaxRotationAng = (DspAxError + 0x48)
    Dsp_AxAreaExceeded = (DspAxError + 0x49)
    Dsp_AxDiStopAct = (DspAxError + 0x50)
    Dsp_SWPELIsDisable = (DspAxError + 0x51)
    Dsp_SWMELIsDisable = (DspAxError + 0x52)
    Dsp_CMPIsDisable = (DspAxError + 0x53)
    # Group fw error
    Dsp_InvalidAxCntInGp = (DspGpError + 0x01)
    Dsp_AxInGpNotFound = (DspGpError + 0x02)
    Dsp_AxIsInOtherGp = (DspGpError + 0x03)
    Dsp_AxCannotIntoGp = (DspGpError + 0x04)
    Dsp_GpInDevNotFound = (DspGpError + 0x05)
    Dsp_InvalidGpCfgVel = (DspGpError + 0x06)
    Dsp_InvalidGpCfgAcc = (DspGpError + 0x07)
    Dsp_InvalidGpCfgDec = (DspGpError + 0x08)
    Dsp_InvalidGpCfgJerk = (DspGpError + 0x09)
    Dsp_InvalidGpParVelLow = (DspGpError + 0x0a)
    Dsp_InvalidGpParVelHigh = (DspGpError + 0x0b)
    Dsp_InvalidGpParAcc = (DspGpError + 0x0c)
    Dsp_InvalidGpParDec = (DspGpError + 0x0d)
    Dsp_InvalidGpParJerk = (DspGpError + 0x0e)
    Dsp_JerkNotSupport = (DspGpError + 0x0f)
    Dsp_ThreeAxNotSupport = (DspGpError + 0x10)
    Dsp_DevIpoNotFinished = (DspGpError + 0x11)
    Dsp_InvalidGpState = (DspGpError + 0x12)
    Dsp_OpenFileFailed = (DspGpError + 0x13)
    Dsp_InvalidPathCnt = (DspGpError + 0x14)
    Dsp_InvalidPathHandle = (DspGpError + 0x15)
    Dsp_InvalidPath = (DspGpError + 0x16)
    Dsp_GpSlavePositionOverMaster = (DspGpError + 0x17)
    Dsp_GpPathBufferOverflow = (DspGpError + 0x19)
    Dsp_InvalidPathFunctionID = (DspGpError + 0x1a)
    Dsp_SysBufAllocateFailed = (DspGpError + 0x1b)
    Dsp_InvalidGpCenterPosition = (DspGpError + 0x1c)
    Dsp_InvalidGpEndPosition = (DspGpError + 0x1d)
    Dsp_InvalidGpCmd = (DspGpError + 0x1e)
    Dsp_AxHasBeenInInGp = (DspGpError + 0x1f)
    Dsp_InvalidPathRange = (DspGpError + 0x20)
    Dsp_InvalidNormVector = (DspGpError + 0x21)
    Dsp_NotANumber = (DspGpError + 0x22)
    Dsp_UnknownCmdID = (DspGpError + 0x23)
    Dsp_InvalidJumpPosi = (DspGpError + 0x24)
    Dsp_DivideByZero = (DspGpError + 0x25)
    Dsp_IrVersionNotSupport = (DspGpError + 0x26)
    Dsp_InvalidIrSource = (DspGpError + 0x27)
    Dsp_InvalidVariableAddress = (DspGpError + 0x28)
    Dsp_IntprIsRunning = (DspGpError + 0x29)
    Dsp_ProgramNotloaded = (DspGpError + 0x2a)
    Dsp_BreakPointsFulled = (DspGpError + 0x2b)
    Dsp_MotionRTError = (DspGpError + 0x2c)
    Dsp_AresAxisConflict = (DspGpError + 0x2d)
    Dsp_CannotBeNegValue = (DspGpError + 0x2e)
    Dsp_AresAxisNotSupport = (DspGpError + 0x2f)
    Dsp_AresAxisNotDefine = (DspGpError + 0x30)
    Dsp_AresNotFindPATHEND = (DspGpError + 0x31)
    Dsp_AresMotionQueueFull = (DspGpError + 0x32)
    Dsp_GpNotReturnPausePosi = (DspGpError + 0x40)
    # ECAT error
    EC_GetNICNumberFailed = (ECTError + 0x0)
    EC_GetNICInfoFailed = (ECTError + 0x1)
    EC_OpenMasterDevFailed = (ECTError + 0x2)
    EC_GetSlaveFailed = (ECTError + 0x3)
    EC_StartOpModeFailed = (ECTError + 0x4)
    EC_CloseDeviceFailed = (ECTError + 0x5)
    EC_MemAllocateFailed = (ECTError + 0x6)
    EC_InvalidNicIndex = (ECTError + 0x7)
    EC_OpenDevFailed = (ECTError + 0x8)
    EC_ReadFileFailed = (ECTError + 0x9)
    EC_GetNicInfoFailed = (ECTError + 0xa)
    EC_GetSDOFailed = (ECTError + 0xb)
    EC_InvalidParameter = (ECTError + 0xc)
    EC_GetPDOOffsetFailed = (ECTError + 0xd)
    EC_InitialMappingInfoFalied = (ECTError + 0xe)
    EC_InitResourceFailed = (ECTError + 0xf)
    EC_SetSDOFailed = (ECTError + 0x10)
    EC_InvalidPortType = (ECTError + 0x11)
    EC_SetCycleTimeFailed = (ECTError + 0x12)
    EC_InvalidAoRange = (ECTError + 0x13)
    EC_InvalidAiRange = (ECTError + 0x14)
    EC_GetSlaveInfoFaied = (ECTError + 0x15)
    EC_GetNetWorkStateFaied = (ECTError + 0x16)
    EC_RegisterEventFailed = (ECTError + 0x17)
    EC_InvalidIntegrationTime = (ECTError + 0x18)
    EC_InvalidAIEnable = (ECTError + 0x19)
    EC_InvalidDIFilter = (ECTError + 0x1a)
    EC_SetSlaveStateFailed = (ECTError + 0x1b)
    EC_ZeroCalibrationFailed = (ECTError + 0x1c)
    EC_InvalidMasterHandle = (ECTError + 0x1d)
    EC_InvalidENIFile = (ECTError + 0x1e)
    EC_InvalidCaliType = (ECTError + 0x1f)
    EC_SetCaliValueFailed = (ECTError + 0x20)
    EC_AOCalibrationFailed = (ECTError + 0x21)
    EC_InvalidIOMapping = (ECTError + 0x22)
    EC_PortIndexGreaterThanPortNum = (ECTError + 0x23)
    EC_ChannelIDGreaterThanChannelNum = (ECTError + 0x24)
    EC_InputIndexGreaterThanInputNum = (ECTError + 0x25)
    EC_OutputIndexGreaterThanOutputNum = (ECTError + 0x26)
    EC_SetEnableFailed = (ECTError + 0x27)
    EC_SetAIRangeFailed = (ECTError + 0x28)
    EC_SetIntegrationTimeFailed = (ECTError + 0x29)
    EC_PropertyNotSupported = (ECTError + 0x2a)
    EC_SlaveIDConflicted = (ECTError + 0x2b)
    EC_SpanCalibrationFailed = (ECTError + 0x2c)
    EC_InvalidAiValue = (ECTError + 0x2d)
    EC_InvalidAoValue = (ECTError + 0x2e)
    EC_GetModuleFailed = (ECTError + 0x2f)
    EC_InvalidCntEnable = (ECTError + 0x30)
    EC_InvalidCntPulseInMode = (ECTError + 0x31)
    EC_InvalidCntInitValue = (ECTError + 0x32)
    EC_InvalidCntMaxValue = (ECTError + 0x33)
    EC_InvalidCntOverflowMode = (ECTError + 0x34)
    EC_InvalidCntLatchEnable = (ECTError + 0x35)
    EC_InvalidCntLatchEdge = (ECTError + 0x36)
    EC_InvalidCntCmpEnable = (ECTError + 0x37)
    EC_InvalidCntCmpMethod = (ECTError + 0x38)
    EC_InvalidCmpDoEnable = (ECTError + 0x39)
    EC_InvalidCmpDoOutputMode = (ECTError + 0x3a)
    EC_InvalidCmpDoLogic = (ECTError + 0x3b)
    EC_InvalidCmpDoPulseWidth = (ECTError + 0x3c)
    EC_AxCntExceeded = (ECTError + 0x3d)
    EC_FWUpgraded = (ECTError + 0x3e)
    EC_InvalidCntPulseInLogic = (ECTError + 0x3f)
    EC_InvalidCntPulseInMaxFreq = (ECTError + 0x40)
    EC_InvalidCntMultiCmpDeviation = (ECTError + 0x41)
    EC_InvalidAoEnable = (ECTError + 0x42)
    EC_InvalidDoEnable = (ECTError + 0x43)
    EC_InvalidCntLatchLogic = (ECTError + 0x44)
    EC_InvalidCmpDoLinkPulseIn = (ECTError + 0x45)
    EC_InvalidDoOutputMode = (ECTError + 0x46)
    EC_InvalidDoLogic = (ECTError + 0x47)
    EC_InvalidDoPulseWidth = (ECTError + 0x48)
    EC_InvalidDoDelayTime = (ECTError + 0x49)
    EC_InvalidDoLinkCmpDo = (ECTError + 0x4a)
    EC_UnequalCmpDataNumbers = (ECTError + 0x4b)
    ECAT_MasterEcatError = (ECTDevError + 0x01)
    ECAT_SlaveDisconnect_R0 = (ECTDevError + 0x02)
    ECAT_SlaveDisconnect_R1 = (ECTDevError + 0x03)
    ECAT_R0_CHECK_OP_TIMEOUT = (ECTDevError + 0x04)
    ECAT_R0_INIT_TIMEOUT = (ECTDevError + 0x05)
    ECAT_R0_START_TIMEOUT = (ECTDevError + 0x06)
    ECAT_R0_GET_SLAVE_ID_TIMEOUT = (ECTDevError + 0x07)
    ECAT_SlaveLostPDOArriveWarnThreshold_R0 = (ECTDevError + 0x08)
    ECAT_SlaveLostPDOArriveWarnThreshold_R1 = (ECTDevError + 0x09)
    ECAT_SlaveModeChange_R0 = (ECTDevError + 0x0A)
    ECAT_SlaveModeChange_R1 = (ECTDevError + 0x0B)
    ECAT_SlaveLostFrame_R0 = (ECTDevError + 0x0C)
    ECAT_SlaveLostFrame_R1 = (ECTDevError + 0x0D)
    ECAT_ReconnectError_R0 = (ECTDevError + 0x0E)
    ECAT_ReconnectError_R1 = (ECTDevError + 0x0F)
    ECAT_R1_CHECK_OP_TIMEOUT = (ECTDevError + 0x10)
    ECAT_R1_INIT_TIMEOUT = (ECTDevError + 0x11)
    ECAT_R1_START_TIMEOUT = (ECTDevError + 0x12)
    ECAT_R1_GET_SLAVE_ID_TIMEOUT = (ECTDevError + 0x13)
    ECAT_R0_GET_DEVICE_TYPE_FAILED = (ECTDevError + 0x14)
    ECAT_R1_GET_DEVICE_TYPE_FAILED = (ECTDevError + 0x15)
    ECAT_SlaveCountNotMatch_R0 = (ECTDevError + 0x16)
    ECAT_SlaveCountNotMatch_R1 = (ECTDevError + 0x17)
    ECAT_AxRetryError = (ECTAxError + 0x01)
    ECAT_AxResetCounterError = (ECTAxError + 0x02)
    ECAT_AxCmdErrorProtection = (ECTAxError + 0x03)
    ECAT_AxSlaveALM = (ECTAxError + 0x04)
    ECAT_AxFollowError = (ECTAxError + 0x05)
    ECAT_AxHomeError = (ECTAxError + 0x06)
    ECAT_AxSlaveStateChanged = (ECTAxError + 0x07)
    ECAT_AxSlaveDoNotReady = (ECTAxError + 0x08)
    ECAT_MOTION_MASTER_NULL = (ECTMotionError + 0x01)
    ECAT_MOTION_SCAN_BUSY = (ECTMotionError + 0x02)
    ECAT_MOTION_DOMAIN_FAILED = (ECTMotionError + 0x03)
    ECAT_MOTION_SLAVE_NOT_SUPPORT = (ECTMotionError + 0x04)
    ECAT_MOTION_SLAVE_CONFIG_FAILED = (ECTMotionError + 0x05)
    ECAT_MOTION_ACTIVE_FAILED = (ECTMotionError + 0x06)
    ECAT_MOTION_DOMAN_DATA_FAILED = (ECTMotionError + 0x07)
    ECAT_MOTION_TOO_MANY_AXES = (ECTMotionError + 0x08)
    ECAT_MOTION_SLAVE_RESCAN = (ECTMotionError + 0x09)
    ECAT_MOTION_SLAVE_REG_ERR_ALIAS = (ECTMotionError + 0x0a)
    ECAT_MOTION_SLAVE_REG_ERR_SET_120 = (ECTMotionError + 0x0b)
    ECAT_MOTION_SLAVE_REG_ERR_GET_130 = (ECTMotionError + 0x0c)
    ECAT_MOTION_SLAVE_REG_ERR_GET_134 = (ECTMotionError + 0x0d)
    ECAT_IO_MASTER_NULL = (ECTIOError + 0x01)
    ECAT_IO_SCAN_BUSY = (ECTIOError + 0x02)
    ECAT_IO_DOMAIN_FAILED = (ECTIOError + 0x03)
    ECAT_IO_SLAVE_NOT_SUPPORT = (ECTIOError + 0x04)
    ECAT_IO_SLAVE_CONFIG_FAILED = (ECTIOError + 0x05)
    ECAT_IO_ACTIVE_FAILED = (ECTIOError + 0x06)
    ECAT_IO_DOMAN_DATA_FAILED = (ECTIOError + 0x07)
    ECAT_IO_SLAVE_RESCAN = (ECTIOError + 0x09)
    # Error from CiA402 ecat driver
    ECTAxOPERATIONMODE = (ECTAxError + 0x10)
    ECTAxHOMEOFFSET = (ECTAxError + 0x20)
    ECTAxHOMEMODE = (ECTAxError + 0x30)
    ECAT_HM_OPMODE_ProtocolTimeout = (ECTAxOPERATIONMODE + 0x01)
    ECAT_HM_OPMODE_ObjectNotExist = (ECTAxOPERATIONMODE + 0x02)
    ECAT_HM_OPMODE_SubindexNotExist = (ECTAxOPERATIONMODE + 0x03)
    ECAT_HM_OPMODE_ValueRangeExceeded = (ECTAxOPERATIONMODE + 0x04)
    ECAT_HM_OPMODE_WrittenTooHigh = (ECTAxOPERATIONMODE + 0x05)
    ECAT_HM_OPMODE_WrittenTooLow = (ECTAxOPERATIONMODE + 0x06)
    ECAT_HM_OPMODE_MaximumLessMinimum = (ECTAxOPERATIONMODE + 0x07)
    ECAT_HM_OPMODE_OTHER = (ECTAxOPERATIONMODE + 0x08)
    ECAT_HM_OFFSET_ProtocolTimeout = (ECTAxHOMEOFFSET + 0x01)
    ECAT_HM_OFFSET_ObjectNotExist = (ECTAxHOMEOFFSET + 0x02)
    ECAT_HM_OFFSET_SubindexNotExist = (ECTAxHOMEOFFSET + 0x03)
    ECAT_HM_OFFSET_ValueRangeExceeded = (ECTAxHOMEOFFSET + 0x04)
    ECAT_HM_OFFSET_WrittenTooHigh = (ECTAxHOMEOFFSET + 0x05)
    ECAT_HM_OFFSET_WrittenTooLow = (ECTAxHOMEOFFSET + 0x06)
    ECAT_HM_OFFSET_MaximumLessMinimum = (ECTAxHOMEOFFSET + 0x07)
    ECAT_HM_OFFSET_OTHER = (ECTAxHOMEOFFSET + 0x08)
    ECAT_HM_MODE_ProtocolTimeout = (ECTAxHOMEMODE + 0x01)
    ECAT_HM_MODE_ObjectNotExist = (ECTAxHOMEMODE + 0x02)
    ECAT_HM_MODE_SubindexNotExist = (ECTAxHOMEMODE + 0x03)
    ECAT_HM_MODE_ValueRangeExceeded = (ECTAxHOMEMODE + 0x04)
    ECAT_HM_MODE_WrittenTooHigh = (ECTAxHOMEMODE + 0x05)
    ECAT_HM_MODE_WrittenTooLow = (ECTAxHOMEMODE + 0x06)
    ECAT_HM_MODE_MaximumLessMinimum = (ECTAxHOMEMODE + 0x07)
    ECAT_HM_MODE_OTHER = (ECTAxHOMEMODE + 0x08)
    # Toggle bit not changed
    ECAT_SDO_ToggleBitNotChanged = (ECTDevSDOError + 0x5300)
    # SDO protocol timeout
    ECAT_SDO_ProtocolTimeout = (ECTDevSDOError + 0x5400)
    # Client/Server command specifier not valid or unknown
    ECAT_SDO_CommandNotValidOrUnknown = (ECTDevSDOError + 0x5401)
    # Out of memory
    ECAT_SDO_OutOfMemory = (ECTDevSDOError + 0x5405)
    # Unsupported access to an object
    ECAT_SDO_UnsupportedAccess = (ECTDevSDOError + 0x6100)
    # Attempt to read a write-only object
    ECAT_SDO_WriteOnlyObject = (ECTDevSDOError + 0x6101)
    # Attempt to write a read-only object
    ECAT_SDO_ReadOnlyObject = (ECTDevSDOError + 0x6102)
    # This object does not exist in the object directory
    ECAT_SDO_ObjectNotExist = (ECTDevSDOError + 0x6200)
    # The object cannot be mapped into the PDO
    ECAT_SDO_MappedToPDOFailed = (ECTDevSDOError + 0x6441)
    # The number and length of the objects to be mapped would exceed the PDO length
    ECAT_SDO_ExceedPdoLength = (ECTDevSDOError + 0x6442)
    # General parameter incompatibility reason
    ECAT_SDO_ParameterIncompatibility = (ECTDevSDOError + 0x6443)
    # General internal incompatibility in device
    ECAT_SDO_InternalIncompatibility = (ECTDevSDOError + 0x6447)
    # Access failure due to a hardware error
    ECAT_SDO_HardwareError = (ECTDevSDOError + 0x6600)
    # Data type does not match, length of service parameter does not match
    ECAT_SDO_LengthNotMatch = (ECTDevSDOError + 0x6710)
    # Data type does not match, length of service parameter too high
    ECAT_SDO_LengthTooHigh = (ECTDevSDOError + 0x6712)
    # Data type does not match, length of service parameter too low
    ECAT_SDO_LengthTooLow = (ECTDevSDOError + 0x6713)
    # Subindex does not exist
    ECAT_SDO_SubindexNotExist = (ECTDevSDOError + 0x6911)
    # Value range of parameter exceeded
    ECAT_SDO_ValueRangeExceeded = (ECTDevSDOError + 0x6930)
    # Value of parameter written too high
    ECAT_SDO_WrittenTooHigh = (ECTDevSDOError + 0x6931)
    # Value of parameter written too low
    ECAT_SDO_WrittenTooLow = (ECTDevSDOError + 0x6932)
    # Maximum value is less than minimum value
    ECAT_SDO_MaximumLessMinimum = (ECTDevSDOError + 0x6936)
    # General error
    ECAT_SDO_GeneralError = (ECTDevSDOError + 0x8000)
    # Data cannot be transferred or stored to the application
    ECAT_SDO_ErrorStoredToApplication = (ECTDevSDOError + 0x8020)
    # Data cannot be transferred or stored to the application because of local control
    ECAT_SDO_ErrorStoredOfLocalControl = (ECTDevSDOError + 0x8021)
    # Data cannot be transferred or stored to the application because of the present device state
    ECAT_SDO_ErrorStoredOfPresentDeviceState = (ECTDevSDOError + 0x8022)
    # Object dictionary dynamic generation fails or no object
    ECAT_SDO_DynamicGenerationFails = (ECTDevSDOError + 0x8023)